C     INCLUDE 'glerl-lib/rgrid.f'
C     INCLUDE 'glerl-lib/rlat.f'
C     INCLUDE 'glerl-lib/rlon.f'
C     INCLUDE 'glerl-lib/xdist.f'
C     INCLUDE 'glerl-lib/ydist.f'

C     INCLUDE 'glerl-lib/wxdr2.f'
C     INCLUDE 'glerl-lib/rxdr2d.f'

C     INCLUDE 'glerl-lib/uzl.f'
C     INCLUDE 'glerl-lib/uzl10.f'

      subroutine masks_dadd
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Defines masks, applies minimum water level depth.   *
C *                                                                    *
C **********************************************************************
C
C      implicit none
C
      include 'pomgl2007.h'
C
      integer i,j
C
C     Initialise and set up free surface mask:
C
      do j=1,jm
	do i=1,im
	  fsm(i,j)=0.e0
	  dum(i,j)=0.e0
	  dvm(i,j)=0.e0
	  if(h(i,j).ne.0.e0) then
	    fsm(i,j)=1.e0
	    h(i,j)=h(i,j)+dadd
	  else
	    h(i,j)=0.5
	  endif
	end do
      end do
C
C     Set up velocity masks:
C
      do j=1,jm
	do i=1,im
	  if(i.gt.1) dum(i,j)=fsm(i,j)*fsm(i-1,j)
	  if(j.gt.1) dvm(i,j)=fsm(i,j)*fsm(i,j-1)
	end do
      end do

      return

      end

      SUBROUTINE READINPUT
      INCLUDE 'pomgl2007.h'
      INTEGER I2D3D(34),IMASK(34)
      CHARACTER*80 LINE
      CHARACTER*3 OUTID(34)

C  LIST OF OUTPUT FIELDS - MUST BE COORDINATED WITH SUBROUTINE OUTP3D

      DATA OUTID /'UT ','VT ','EG ','HF ','SHF','LHF','SWR','LWR',
     1            'TX ','TY ','TM ','SM ','U  ','V  ','W  ','T  ',
     2            'S  ','KM ','KH ','AAM','UTC','VTC','UC ','VC',
     3            'UTM','VTM','UM ','VM ','UCM','VCM','Q2 ','L',
     4            'KMM','KHM'/

C  2D/3D INDICATOR

      DATA I2D3D /  2,    2,    2,    2,    2,    2,    2,    2,
     1              2,    2,    3,    3,    3,    3,    3,    3,
     2              3,    3,    3,    3,    2,    2,    3,    3,    
     3              2,    2,    3,    3,    3,    3,    3,    3,
     4              3,    3/

C  MASK INDICATOR (1 = FSM, 2 = DUM, 3 = DVM)

      DATA IMASK /  2,    3,    1,    1,    1,    1,    1,    1,
     1              2,    3,    1,    1,    2,    3,    1,    1,
     2              1,    1,    1,    1,    1,    1,    1,    1,
     3              2,    3,    2,    3,    1,    1,    1,    1,
     4              1,    1/
       
      NOUTID=34
     
      WRITE(6,*) 'PRINCETON OCEAN MODEL - GREAT LAKES'
      WRITE(6,7029) IM,JM,KB
 7029 FORMAT(' IM = ',I5,'   JM = ',I5,'   KB = ',I5)
      WRITE(6,*) ' '  
      WRITE(6,*) '[POMGL CONTROL]'
C------------------------------------------------------------------
C  READ FIRST SECTION
C------------------------------------------------------------------
      READ(5,'(A)') LINE
      IF(LINE.NE.'[POMGL CONTROL]') THEN
       WRITE(6,4418)
 4418  FORMAT(10X,'INCORRECT INPUT FILE FORMAT - STOP')
       STOP
      ENDIF
      READ(5,'(A)') FGRID  
      READ(5,'(A)') FINPUT
      READ(5,'(A)') FOUT  
      READ(5,'(A)') FINIT
      READ(5,*) MODE
      READ(5,*) IYR,IJD,IHR   
      READ(5,*) DTE 
      READ(5,*) DTI 
      READ(5,*) IHRS 
      READ(5,*) DTWIND  
      READ(5,*) NLEVEL  
	IF(NLEVEL.GT.0) THEN
	   IF(NLEVEL.NE.KB) THEN
	   WRITE(6,4419) 
 4419      FORMAT(10X,'NUMBER LEVELS MUST EQUAL KB - STOP')
	   STOP
	   ENDIF 
	READ(5,*) (Z(K),K=1,KB) 
	ENDIF  
C--------------------------------------------------------------------------
C WRITE INPUT PARAMETERS TO STANDARD OUT  
      WRITE(6,7030) FGRID,FINPUT,FOUT,FINIT
 7030 FORMAT(' BATHYMETRY FILE FGRID ='/2X,A80/
     1       ' INPUT FILE PREFIX FINPUT ='/2X,A80/
     2       ' OUTPUT FILE PREFIX FOUT ='/2X,A80/ 
     3       ' INITIAL CONDITION FILE FINIT ='/2X,A80) 
      WRITE(6,7031) MODE
 7031 FORMAT(' MODE   = ',I8) 
      WRITE(6,7032) IYR,IJD,IHR 
 7032 FORMAT(' START YEAR = ',I6,/,
     1       ' START DAY  = ',I6,/,
     2       ' START HOUR = ',I6) 
      WRITE(6,7033) DTE
 7033 FORMAT(' DTE    = ',F10.2) 
      WRITE(6,7034) DTI
 7034 FORMAT(' DTI    = ',F10.2)  
      WRITE(6,7035) IHRS
 7035 FORMAT(' IHRS  = ',I7) 
      WRITE(6,7036) DTWIND
 7036 FORMAT(' DTWIND = ',F10.2) 
      WRITE(6,7037) NLEVEL 
 7037 FORMAT(' NLEVEL = ',I7) 

C  USE GLERL BATHYMETRY FOR GREAT LAKES 
C  GET DEPTH GRID FROM LUN 7

      OPEN(UNIT=7,FORM='FORMATTED',STATUS='OLD',FILE=FGRID) 
      CALL RGRID(7,H,IM,JM)
      CLOSE(7)

      DS=RPARM(3)
      DEPMAX=RPARM(4)  
      WRITE(6,7045) DEPMAX
 7045 FORMAT(' DEPMAX   = ',F10.2)  
      WRITE(6,7047) DS
 7047 FORMAT(' DS     = ',F10.2) 
C------------------------------------------------------------------
C  READ SECOND SECTION
C------------------------------------------------------------------
      READ(5,'(A)') LINE
      IF(LINE.NE.'[POMGL CONSTANTS]') THEN
       WRITE(6,4420)
 4420  FORMAT(10X,'INCORRECT INPUT FILE FORMAT (SECTION 2) - STOP')
       STOP
      ENDIF
      WRITE(6,*) ' '  
      WRITE(6,*) '[POMGL CONSTANTS]'

C  SET DEFAULT VALUES FOR MODEL PARAMETERS

      ISPADV=1
      HORCON=0.1
      tprni=1.0
      SMOTH=0.1
      UMOL=2.E-5
      TBIAS=10.0
      SBIAS=35.0
      ALPHA=0.225
      RAMPDT=0.
      aam_init=20.0
      DADD=0.0
      CBCMIN=0.0025
      nread=0
      nbct=1
      ITMEAN=0
      ISFLUX=0
      SMAGOR=0.
      YAMADA=0.
      YAMADA1=0.
      IAVG=1
      TAUX=0.
      TAUY=0.
      INEUTR=0
      NRSTRT=0
      NRSKIP=0
      nadv=1
      nitera=2
      sw=0.5e0
      nbcs=1
      ntp=2
      ICE=0
  
 4421 READ(5,'(A)',END=4430) LINE

C  CHECK FOR OVERRIDE VALUES FOR MODEL CONSTANTS

      IF(LINE(1:7).EQ.'ISPADV=')  THEN 
	READ(LINE(8:80),*) ISPADV
	GOTO 7099
      ENDIF
	
      IF(LINE(1:7).EQ.'HORCON=')  THEN
	READ(LINE(8:80),*) HORCON
	GOTO 7099
      ENDIF     
      
      IF(LINE(1:6).EQ.'tprni=')  THEN
	READ(LINE(7:80),*) tprni
	GOTO 7099      
      ENDIF
      
      IF(LINE(1:6).EQ.'SMOTH=')  THEN
	READ(LINE(7:80),*) SMOTH
	GOTO 7099
      ENDIF
	     
      IF(LINE(1:5).EQ.'UMOL=')  THEN
	READ(LINE(6:80),*) UMOL
	GOTO 7099
      ENDIF
      
      IF(LINE(1:6).EQ.'TBIAS=')  THEN
	READ(LINE(7:80),*) TBIAS
	GOTO 7099
      ENDIF
      
      IF(LINE(1:6).EQ.'SBIAS=')  THEN
	READ(LINE(7:80),*) SBIAS
	GOTO 7099
      ENDIF
      
      IF(LINE(1:6).EQ.'ALPHA=')  THEN
	READ(LINE(7:80),*) ALPHA
	GOTO 7099
      ENDIF
      
      IF(LINE(1:7).EQ.'RAMPDT=')  THEN
	READ(LINE(8:80),*) RAMPDT
	GOTO 7099
      ENDIF
      
      IF(LINE(1:9).EQ.'aam_init=')  THEN
	READ(LINE(10:80),*) aam_init
	GOTO 7099
      ENDIF
      
      IF(LINE(1:5).EQ.'DADD=')  THEN      
	READ(LINE(6:80),*) DADD
	GOTO 7099
      ENDIF
      
      IF(LINE(1:7).EQ.'CBCMIN=')  THEN
	READ(LINE(8:80),*) CBCMIN
	GOTO 7099
      ENDIF
      
      IF(LINE(1:7).EQ.'nread=')  THEN
	READ(LINE(8:80),*) nread
	GOTO 7099
      ENDIF
      
      IF(LINE(1:5).EQ.'nbct=')  THEN
	READ(LINE(6:80),*) nbct
	GOTO 7099
      ENDIF
      
      IF(LINE(1:7).EQ.'ITMEAN=')  THEN
	READ(LINE(8:80),*) ITMEAN
	GOTO 7099
      ENDIF
      
      IF(LINE(1:7).EQ.'ISFLUX=')  THEN
	READ(LINE(8:80),*) ISFLUX
	GOTO 7099
      ENDIF
      
      IF(LINE(1:7).EQ.'SMAGOR=')  THEN
	READ(LINE(8:80),*) SMAGOR
	GOTO 7099
      ENDIF
      
      IF(LINE(1:7).EQ.'YAMADA=') THEN
	READ(LINE(8:80),*) YAMADA
	GOTO 7099
      ENDIF
      
      IF(LINE(1:8).EQ.'YAMADA1=') THEN
	READ(LINE(9:80),*) YAMADA1
	GOTO 7099
      ENDIF
      
      IF(LINE(1:5).EQ.'IAVG=') THEN
	READ(LINE(6:80),*) IAVG
	GOTO 7099
      ENDIF

      IF(LINE(1:5).EQ.'TAUX=') THEN
	READ(LINE(6:80),*) TAUX
	GOTO 7099
      ENDIF

      IF(LINE(1:5).EQ.'TAUY=') THEN
	READ(LINE(6:80),*) TAUY
	GOTO 7099
      ENDIF

      IF(LINE(1:7).EQ.'INEUTR=')  THEN
	READ(LINE(8:80),*) INEUTR
	GOTO 7099
      ENDIF

      IF(LINE(1:7).EQ.'NRSTRT=')  THEN
	READ(LINE(8:80),*) NRSTRT
	GOTO 7099
      ENDIF

      IF(LINE(1:7).EQ.'NRSKIP=')  THEN
	READ(LINE(8:80),*) NRSKIP
	GOTO 7099
      ENDIF

      IF(LINE(1:5).EQ.'nadv=')  THEN
	READ(LINE(6:80),*) nadv
	GOTO 7099
      ENDIF

      IF(LINE(1:7).EQ.'nitera=')  THEN
	READ(LINE(8:80),*) nitera
	GOTO 7099
      ENDIF

      IF(LINE(1:3).EQ.'sw=')  THEN
	READ(LINE(4:80),*) sw
	GOTO 7099
      ENDIF

      IF(LINE(1:5).EQ.'nbcs=')  THEN
	READ(LINE(6:80),*) nbcs
	GOTO 7099
      ENDIF

      IF(LINE(1:4).EQ.'ntp=')  THEN
	READ(LINE(5:80),*) ntp
	GOTO 7099
      ENDIF

      IF(LINE(1:4).EQ.'ICE=')  THEN
	READ(LINE(5:80),*) ICE
	GOTO 7099
      ENDIF

      IF(LINE.NE.'[POMGL OUTPUT]') THEN
	WRITE(6,*) '   UNRECOGNIZED PARAMETER (SEE LINE BELOW) - STOP'
	WRITE(6,*) LINE
	STOP
      ENDIF     

 7099 IF(LINE.NE.'[POMGL OUTPUT]') GOTO 4421

      WRITE(6,7100) ISPADV 
 7100 FORMAT(' ISPADV = ',I10)  
      WRITE(6,7101) HORCON
 7101 FORMAT(' HORCON = ',F10.4) 
      WRITE(6,7102) tprni 
 7102 FORMAT(' tprni  = ',F10.2)
      WRITE(6,7103) SMOTH
 7103 FORMAT(' SMOTH  = ',F10.2) 
      WRITE(6,7104) UMOL
 7104 FORMAT(' UMOL   = ',E10.3) 
      WRITE(6,7105) TBIAS
 7105 FORMAT(' TBIAS  = ',F10.2) 
      WRITE(6,7106) SBIAS
 7106 FORMAT(' SBIAS  = ',F10.2) 
      WRITE(6,7107) ALPHA
 7107 FORMAT(' ALPHA  = ',F10.3) 
      WRITE(6,7108) RAMPDT
 7108 FORMAT(' RAMPDT = ',F10.2) 
      WRITE(6,7109) DADD
 7109 FORMAT(' DADD   = ',F10.2) 
      WRITE(6,7110) aam_init
 7110 FORMAT(' aam_init   = ',F10.2) 
      WRITE(6,7111) CBCMIN
 7111 FORMAT(' CBCMIN = ',F10.5) 
      WRITE(6,7112) nread
 7112 FORMAT(' nread = ',I10) 
      WRITE(6,7113) nbct
 7113 FORMAT(' nbct  = ',I10) 
      WRITE(6,7114) ITMEAN
 7114 FORMAT(' ITMEAN = ',I10) 
      WRITE(6,7115) ISFLUX
 7115 FORMAT(' ISFLUX = ',I10) 
      WRITE(6,7116) SMAGOR
 7116 FORMAT(' SMAGOR = ',F10.2) 
      WRITE(6,7117) YAMADA
 7117 FORMAT(' YAMADA = ',E10.3) 
      WRITE(6,7118) YAMADA1
 7118 FORMAT(' YAMADA1= ',E10.3) 
      WRITE(6,7119) IAVG
 7119 FORMAT(' IAVG   = ',I10) 
      WRITE(6,7120) TAUX
 7120 FORMAT(' TAUX   = ',E10.3) 
      WRITE(6,7121) TAUY
 7121 FORMAT(' TAUY   = ',E10.3) 
      WRITE(6,7122) INEUTR
 7122 FORMAT(' INEUTR = ',I10) 
      WRITE(6,7123) NRSTRT
 7123 FORMAT(' NRSTRT = ',I10) 
      WRITE(6,7124) NRSKIP
 7124 FORMAT(' NRSKIP = ',I10) 
      WRITE(6,7125) nadv
 7125 FORMAT(' nadv = ',I10) 
      WRITE(6,7126) nitera
 7126 FORMAT(' nitera = ',I10) 
      WRITE(6,7127) sw
 7127 FORMAT(' sw   = ',F10.2) 
      WRITE(6,7128) nbcs
 7128 FORMAT(' nbcs = ',I10) 
      WRITE(6,7129) ntp
 7129 FORMAT(' ntp = ',I10) 
      WRITE(6,7130) ICE
 7130 FORMAT(' ICE = ',I10) 


C DEFINE THE MASKS AND APPLY MINIMUM WATER LEVEL DEPTH DADD 

      call masks_dadd

C COUNT THE LAKE H, U, V POINTS FOR USE IN WRITING DATA TO FILES 

      NFSM=0
      NDUM=0
      NDVM=0
      DO 42 J=1,JM
      DO 42 I=1,IM
      IF(FSM(I,J).NE.0.) NFSM=NFSM+1
      IF(DUM(I,J).NE.0.) NDUM=NDUM+1
      IF(DVM(I,J).NE.0.) NDVM=NDVM+1
42    CONTINUE
      WRITE(6,*) ' '
      WRITE(6,*) 'MASK ARRAY NONZERO ELEMENTS:'
      WRITE(6,'(A,I7,A,I7,A,I7)')
     1   '  NFSM=',NFSM,'  NDUM=',NDUM,'  NDVM=',NDVM

C   DETERMINE THE VERTICAL DISTRIBUTION OF Z LEVELS

      IF(NLEVEL.GT.0) THEN
	DO 59 K=1,KBM1
	ZZ(K)=0.5*(Z(K)+Z(K+1))  
   59   CONTINUE  
	ZZ(KB)=-1.0+0.5*(Z(KB)-Z(KBM1))  
	DO 60 K=1,KBM1
	DZ(K)=Z(K)-Z(K+1)
   60   DZZ(K)=ZZ(K)-ZZ(K+1)
	DO 20 K=1,KBM1
  20    DZR(K)=1./DZ(K)
      ELSE 
	CALL DEPTH
      ENDIF

C  PRINT THE VERTICAL DISTRIBUTIONS  

      WRITE(6,*) 'SIGMA LEVELS'
      WRITE(6,70)
   70 FORMAT(5X,'K',7X,'Z',9X,'ZZ',8X,'DZ',7X,'DZZ')
      DO 90 K=1,KB
      WRITE(6,888) K,Z(K),ZZ(K),DZ(K),DZZ(K)
  888 FORMAT(' ',I5,4F10.3)
   90 CONTINUE  

C------------------------------------------------------------------
C  READ THIRD SECTION
C------------------------------------------------------------------
      WRITE(6,*) ' '  
      WRITE(6,*) '[POMGL OUTPUT]'
      WRITE(6,*) 'ID    I   J   K  NDTI ITYPE LUN  2D/3D  MASK'
      NOUT=0
      NLUN=21
 4424 READ(5,'(A3,1X,I3,1X,I3,1X,I3,1X,I5)',END=4429) LINE,IX,JX,KX,NDTX
      IF(LINE.EQ.' ') GO TO 4429

C  IJKOUT(1) = ID OF MODEL FIELD
C  IJKOUT(2) = IX
C  IJKOUT(3) = JX
C  IJKOUT(4) = KX
C  IJKOUT(5) = NDTX
C  IJKOUT(6) = OUTPUT TYPE
C  IJKOUT(7) = LUN
C  IJKOUT(8) = 2D/3D FLAG
C  IJKOUT(9) = MASK (1 = FSM, 2 = DUM, 3 = DVM)

      NOUT=NOUT+1
      IJKOUT(1,NOUT)=0

      DO 100 I=1,NOUTID
       IF(LINE.EQ.OUTID(I)) THEN
	IJKOUT(1,NOUT)=I
	IJKOUT(8,NOUT)=I2D3D(I)
	IJKOUT(9,NOUT)=IMASK(I)
       ENDIF
  100 CONTINUE

C  CHECK IF REQUESTED PARAMETER IS IN LIST

      IF(IJKOUT(1,NOUT).EQ.0) THEN
       WRITE(6,4425) LINE(1:25)
 4425  FORMAT(' UNRECOGNIZED OUTPUT PARAMETER: ',A25)
       NOUT=NOUT-1
      ELSE

C  I,J,K,DT FOR OUTPUT FIELD

       IJKOUT(2,NOUT)=IX
       IJKOUT(3,NOUT)=JX
       IJKOUT(4,NOUT)=KX
       IJKOUT(5,NOUT)=NDTX

C  FOR TIME AVERAGED FIELDS, USE IAVG FOR NDTX

       IF(IJKOUT(1,NOUT).GE.25.AND.IJKOUT(1,NOUT).LE.30) 
     1   IJKOUT(5,NOUT)=IAVG
     
C  SET OUTPUT TYPE AND LUN

C  OUTPUT TYPE:
C    1=TIME SERIES OF 2D VARIABLE
C    2=FULL 2D FIELD
C    3=FULL 3D FIELD
C    4=TIME SERIES OF 3D VARIABLE
C    5=ISLICE OF 3D FIELD
C    6=JSLICE OF 3D FIELD
C    7=KSLICE OF 3D FIELD
C    8=KSLICE OF 3D FIELD MASKED TO 2D
C
C  LUN=20 FOR ALL TIME SERIES VARIABLES
C     =21,22,23,... FOR 2D AND 3D VARIABLES

       IF(IJKOUT(8,NOUT).EQ.2) THEN
	IF(IX.NE.0.AND.JX.NE.0) THEN
	 IJKOUT(6,NOUT)=1 
	ELSE
	 IJKOUT(6,NOUT)=2
	ENDIF
       ENDIF
       IF(IJKOUT(8,NOUT).EQ.3) THEN
	IF(IX.EQ.0.AND.JX.EQ.0.AND.KX.EQ.0)   IJKOUT(6,NOUT)=3 
	IF(IX.NE.0.AND.JX.NE.0)               IJKOUT(6,NOUT)=4 
	IF(IX.NE.0.AND.JX.EQ.0.AND.KX.EQ.0)   IJKOUT(6,NOUT)=5 
	IF(IX.EQ.0.AND.JX.NE.0.AND.KX.EQ.0)   IJKOUT(6,NOUT)=6 
	IF(IX.EQ.0.AND.JX.EQ.0.AND.KX.NE.0)   IJKOUT(6,NOUT)=7 
	IF(IX.EQ.0.AND.JX.EQ.0.AND.KX.GT.100) IJKOUT(6,NOUT)=8 

       ENDIF
       
C  SET LUN

       IF(IJKOUT(6,NOUT).EQ.1.OR.IJKOUT(6,NOUT).EQ.4) THEN
	IJKOUT(7,NOUT)=20
       ELSE
	IJKOUT(7,NOUT)=NLUN
	NLUN=NLUN+1
       ENDIF
       
       WRITE(6,4426) LINE(1:3),(IJKOUT(I,NOUT),I=2,9)
 4426  FORMAT(1X,A3,3I4,I6,I4,3I6)
      ENDIF
      GOTO 4424

 4429 CONTINUE 
      RETURN

 4430 WRITE(6,4431)
 4431 FORMAT(10X,'END OF FILE ENCOUNTERED ON INPUT FILE - STOP')
      STOP
      END

      SUBROUTINE OUTP3D
      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'
C
      CHARACTER*3 FEXT1(34)
      CHARACTER*12 FEXT2
      SAVE IFIRST
C
      DATA IFIRST/1/
      DATA FEXT1/'ut ','vt ','eg ','hf ','shf','lhf','swr','lwr',
     1           'tx ','ty ','tm ','sm ','u  ','v  ','w  ','t  ',
     2           's  ','km ','kh ','aam','utc','vtc','uc ','vc ',
     3           'utm','vtm','um ','vm ','ucm','vcm','q2 ','l',
     4           'kmm','khm'/
      
C--------------------------------------------------------------------
C ON FIRST TIME STEP OPEN XDR OUTPUT FILES 

      IF(IFIRST.EQ.1) THEN
       K=INDEX(FOUT,' ')
       WRITE(6,*) 'OPENING OUTPUT FILES:'
       
C  OPEN FILE FOR TIME SERIES VARIABLES

       FNAME=FOUT(1:K-1)//'.1d '
       CALL XDREN(20,FNAME)

C OPEN FILE FOR VORTICITY BALANCE RESULTS

       K=INDEX(FOUT,' ') 
       OPEN(95,FILE=FOUT(1:K-1)//'.vor',STATUS='UNKNOWN')

       DO 10 I=1,NOUT

C  SKIP 1D VARIABLES

	IF(IJKOUT(7,I).EQ.20) GO TO 10

C  SET UP FILE NAME FOR FULL 2D AND 3D FIELDS

	FNAME=FOUT(1:K-1)//'.'//FEXT1(IJKOUT(1,I))//' '

	IF(IJKOUT(6,I).GE.5) THEN

C  SET UP FILE NAME FOR PARTIAL FIELDS

	 J=INDEX(FNAME,' ')
	 WRITE(FEXT2,'(A1,I3.3,A1,I3.3,A1,I3.3)') '.',IJKOUT(2,I),
     1    '.',IJKOUT(3,I),'.',IJKOUT(4,I)
	 FNAME=FNAME(1:J-1)//FEXT2//' '
	ENDIF

C  OPEN FILE, UNIT NUMBER = INDEX + 20

	WRITE(6,'(1X,A)') FNAME
	NLUN=IJKOUT(7,I)
	CALL XDREN(NLUN,FNAME)

   10  CONTINUE
       IFIRST=0
       
C  PRINT HEADER

       WRITE(6,'(3A)')'  IINT      HRS    YR  JD  HR   VMAX   TMAX IMX',
     1  ' JMX  TMIN IMN JMN    RMSV        RMSVV       RMSE   ',
     2  '    TAVG     NOISE  DMIN  IMN  JMN   WLTOT'  
      ENDIF

C PRINT TIME, MAX VELOCITY, MAX AND MIN TEMPERATURES, RMS VELOCITY,
C  RMS VERTICAL VELOCITY, RMS SURFACE FLUCTUATION, AVERAGE TEMPERATURE,
C  2DX NOISE AND MINIMUM DEPTH


      CALL TMAXMIN(TMAX,IMAX,JMAX,TMIN,IMIN,JMIN)
      CALL DMAXMIN(DMAX,IMAX1,JMAX1,DMIN,IMIN1,JMIN1)
      CALL RMSVAL(RMSV,RMSVV,RMSE,TAVG,TDEVS)
      HOURS=IINT*DTI/3600.

      WRITE(6,'(I6,F10.2,I5,I4,I3,F8.3,1X,2(F6.2,2I4),4E12.5,2F6.2,
     1       2I4,E13.5)')
     2  IINT,HOURS,IYR0,IJD0,IHR0,VAMAX,TMAX,IMAX,JMAX,TMIN,IMIN,
     3  JMIN,RMSV,RMSVV,RMSE,TAVG,TDEVS,DMIN,IMIN1,JMIN1,WLTOT

      WLTOT=0.

C  ADD TO 2D AND 3D TIME-AVERAGED VELOCITY ARRAYS

      DO 3 J=1,JM
      DO 3 I=1,IM
       IF(I.GT.1)
     1  UTM(I,J)=UTM(I,J)+(UTB(I,J)+UTF(I,J))/(DT(I,J)+DT(I-1,J))
       IF(J.GT.1)
     1  VTM(I,J)=VTM(I,J)+(VTB(I,J)+VTF(I,J))/(DT(I,J)+DT(I,J-1))
    3 CONTINUE

C Take care of West and South open boundaries (for cosmetic-plotting purpose only)

	do j=1,jm
C
C     West:
C
	  if(dum(1,j).gt.0.e0) utm(1,j)=utm(2,j)
	end do

	do i=1,im
C
C     South:
C
	  if(dvm(i,1).gt.0.e0) vtm(i,1)=vtm(i,2)
	end do

    
      DO 4 K=1,KB
      DO 4 J=1,JM
      DO 4 I=1,IM
       UM(I,J,K)=UM(I,J,K)+U(I,J,K)
       VM(I,J,K)=VM(I,J,K)+V(I,J,K)

       KMM(I,J,K)=KMM(I,J,K)+KM(I,J,K)
       KHM(I,J,K)=KHM(I,J,K)+KH(I,J,K)
    4 CONTINUE
    
C  CHECK FOR END OF AVERAGING PERIOD AND CALCULATE TIME AVERAGES

      IF(MOD(IINT,IAVG).EQ.0) THEN
       DO 5 J=1,JM
       DO 5 I=1,IM
	UTM(I,J)=UTM(I,J)/FLOAT(IAVG)
	VTM(I,J)=VTM(I,J)/FLOAT(IAVG)
    5  CONTINUE
    
       DO 6 K=1,KB
       DO 6 J=1,JM
       DO 6 I=1,IM
	UM(I,J,K)=UM(I,J,K)/FLOAT(IAVG)
	VM(I,J,K)=VM(I,J,K)/FLOAT(IAVG)

	KMM(I,J,K)=KMM(I,J,K)/FLOAT(IAVG)
	KHM(I,J,K)=KHM(I,J,K)/FLOAT(IAVG)
    6  CONTINUE
      ENDIF      
    
      DO 200 I=1,NOUT

C  CHECK IF THIS FIELD SHOULD BE OUTPUT AT THIS TIME STEP

       IF(MOD(IINT,IJKOUT(5,I)).EQ.0) THEN
	ID=IJKOUT(1,I)
	IX=IJKOUT(2,I)
	JX=IJKOUT(3,I)
	KX=IJKOUT(4,I)
	ITYPE=IJKOUT(6,I)
	IMASK=IJKOUT(9,I)
	
C  -----------------------   2-D FIELDS   --------------------------------

C  FOR UT,VT, AND EG, CALCULATE TIME-AVERAGE USING UTB-UTF,VTB-VTF,EGB-EGF

	IF(IJKOUT(1,I).EQ.1) THEN
	 DO 11 J=1,JMM1
	 DO 11 II=2,IMM1
	  TPS(II,J)=(UTB(II,J)+UTF(II,J))/(DT(II,J)+DT(II-1,J))
   11    CONTINUE
	CALL OUT2(ID,I,TPS,IX,JX,ITYPE,IMASK)
	ENDIF

	IF(IJKOUT(1,I).EQ.2) THEN
	 DO 12 J=2,JMM1
	 DO 12 II=1,IMM1
	  TPS(II,J)=(VTB(II,J)+VTF(II,J))/(DT(II,J)+DT(II,J-1))
	  TPS(II,J)=(VTB(II,J)+VTF(II,J))
   12    CONTINUE
	CALL OUT2(ID,I,TPS,IX,JX,ITYPE,IMASK)
	ENDIF

	IF(IJKOUT(1,I).EQ.3) THEN
	 DO 13 J=1,JMM1
	 DO 13 II=1,IMM1
	  TPS(II,J)=0.5*(EGB(II,J)+EGF(II,J))
   13    CONTINUE
	CALL OUT2(ID,I,TPS,IX,JX,ITYPE,IMASK)
	ENDIF

	IF(IJKOUT(1,I).EQ.9) CALL OUT2(ID,I,WUSURF,IX,JX,ITYPE,IMASK)
	IF(IJKOUT(1,I).EQ.10) CALL OUT2(ID,I,WVSURF,IX,JX,ITYPE,IMASK)

C  FOR UTC AND VTC, CALCULATE VALUES AT GRID CENTERS

	IF(IJKOUT(1,I).EQ.21) THEN
	 DO 14 J=1,JMM1
	 DO 14 II=2,IMM2
	  TPS(II,J)=0.5*((UTB(II,J)+UTF(II,J))/(DT(II,J)+DT(II-1,J))+
     1     (UTB(II+1,J)+UTF(II+1,J))/(DT(II,J)+DT(II+1,J)))
   14    CONTINUE
	 CALL OUT2(ID,I,TPS,IX,JX,ITYPE,IMASK)
	ENDIF
	IF(IJKOUT(1,I).EQ.22) THEN
	 DO 15 J=2,JMM2
	 DO 15 II=1,IMM1
	  TPS(II,J)=0.5*((VTB(II,J)+VTF(II,J))/(DT(II,J)+DT(II,J-1))+
     1     (VTB(II,J+1)+VTF(II,J+1))/(DT(II,J)+DT(II,J+1)))
   15    CONTINUE
	 CALL OUT2(ID,I,TPS,IX,JX,ITYPE,IMASK)
	ENDIF

C  TIME AVERAGED FIELDS

	IF(IJKOUT(1,I).EQ.25) CALL OUT2(ID,I,UTM,IX,JX,ITYPE,IMASK)
	IF(IJKOUT(1,I).EQ.26) CALL OUT2(ID,I,VTM,IX,JX,ITYPE,IMASK)

C  THESE FIELDS ARE ONLY CALCULATED FOR MODE=3 AND MODE=4

	IF(MODE.GE.3) THEN

C  CONVERT HEAT FLUX TO W/M**2 AND CHANGE THE SIGN
	 IF(IJKOUT(1,I).EQ.4) THEN
	  CONV1=-4186.*1000.*1.025
	  DO 16 J=1,JM
	  DO 16 II=1,IM
	   TPS(II,J)=WTSURF(II,J)*CONV1
   16     CONTINUE
	  CALL OUT2(ID,I,TPS,IX,JX,ITYPE,IMASK)
	 ENDIF
	 
C  CONVERT SHORTWAVE RADIATION  TO W/M**2 AND CHANGE THE SIGN
	 IF(IJKOUT(1,I).EQ.7) THEN
	  CONV1=-4186.*1000.*1.025
	  DO 17 J=1,JM
	  DO 17 II=1,IM
	   TPS(II,J)=SWRAD(II,J)*CONV1
   17     CONTINUE
	  CALL OUT2(ID,I,TPS,IX,JX,ITYPE,IMASK) 
	 ENDIF

C  OTHER HEAT FLUX COMPONENTS ARE ALREADY IN W/M**2         
	 IF(IJKOUT(1,I).EQ.5) CALL OUT2(ID,I,SHF,IX,JX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.6) CALL OUT2(ID,I,LHF,IX,JX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.8) CALL OUT2(ID,I,LWR,IX,JX,ITYPE,IMASK)

C  -----------------------   3-D FIELDS   --------------------------------
	 IF(IJKOUT(1,I).EQ.13) CALL OUT3(ID,I,U,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.14) CALL OUT3(ID,I,V,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.15) CALL OUT3(ID,I,W,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.27) CALL OUT3(ID,I,UM,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.28) CALL OUT3(ID,I,VM,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.31) CALL OUT3(ID,I,Q2,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.32) CALL OUT3(ID,I,L,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.33) CALL OUT3(ID,I,KMM,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.34) CALL OUT3(ID,I,KHM,IX,JX,KX,ITYPE,IMASK)
C 
C ADD TBIAS TO TEMP AND SBIAS TO SALINITY BEFORE WRITING TO OUTPUT DATA FILES
C  (USES A AS TEMPORARY STORAGE)
C
	 IF(IJKOUT(1,I).EQ.11) THEN
	  DO 20 K=1,KBM1
	  DO 20 J=1,JM
	  DO 20 II=1,IM
	   A(II,J,K)=TMEAN(II,J,K)+TBIAS
   20     CONTINUE
	  CALL OUT3(ID,I,A,IX,JX,KX,ITYPE,IMASK)
	 ENDIF
	 IF(IJKOUT(1,I).EQ.12) THEN
	  DO 25 K=1,KBM1
	  DO 25 J=1,JM
	  DO 25 II=1,IM
	   A(II,J,K)=SMEAN(II,J,K)+SBIAS
   25     CONTINUE
	  CALL OUT3(ID,I,A,IX,JX,KX,ITYPE,IMASK)
	 ENDIF
	 IF(IJKOUT(1,I).EQ.16) THEN
	  DO 35 K=1,KBM1
	  DO 35 J=1,JM
	  DO 35 II=1,IM
	   A(II,J,K)=T(II,J,K)+TBIAS
   35     CONTINUE
	  CALL OUT3(ID,I,A,IX,JX,KX,ITYPE,IMASK)
	 ENDIF
	 IF(IJKOUT(1,I).EQ.17) THEN
	  DO 45 K=1,KBM1
	  DO 45 J=1,JM
	  DO 45 II=1,IM
	   A(II,J,K)=S(II,J,K)+SBIAS
   45     CONTINUE
	  CALL OUT3(ID,I,A,IX,JX,KX,ITYPE,IMASK)
	 ENDIF
	 IF(IJKOUT(1,I).EQ.18) CALL OUT3(ID,I,KM,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.19) CALL OUT3(ID,I,KH,IX,JX,KX,ITYPE,IMASK)
	 IF(IJKOUT(1,I).EQ.20) CALL OUT3(ID,I,AAM,IX,JX,KX,ITYPE,IMASK)

C  FOR UC, VC, UCM AND VCM, CALCULATE VALUES AT GRID CENTERS

	 IF(IJKOUT(1,I).EQ.23) THEN
	  DO 46 K=1,KB
	  DO 46 J=1,JMM1
	  DO 46 II=1,IMM1
	   A(II,J,K)=0.5*(U(II,J,K)+U(II+1,J,K))
   46     CONTINUE
	  CALL OUT3(ID,I,A,IX,JX,KX,ITYPE,IMASK)
	 ENDIF
	 IF(IJKOUT(1,I).EQ.24) THEN
	  DO 47 K=1,KB
	  DO 47 J=1,JMM1
	  DO 47 II=1,IMM1
	   A(II,J,K)=0.5*(V(II,J,K)+V(II,J+1,K))
   47     CONTINUE
	  CALL OUT3(ID,I,A,IX,JX,KX,ITYPE,IMASK)
	 ENDIF
	 IF(IJKOUT(1,I).EQ.29) THEN
	  DO 48 K=1,KB
	  DO 48 J=1,JMM1
	  DO 48 II=1,IMM1
	   A(II,J,K)=0.5*(UM(II,J,K)+UM(II+1,J,K))
   48     CONTINUE
	  CALL OUT3(ID,I,A,IX,JX,KX,ITYPE,IMASK)
	 ENDIF
	 IF(IJKOUT(1,I).EQ.30) THEN
	  DO 49 K=1,KB
	  DO 49 J=1,JMM1
	  DO 49 II=1,IMM1
	   A(II,J,K)=0.5*(VM(II,J,K)+VM(II,J+1,K))
   49     CONTINUE
	  CALL OUT3(ID,I,A,IX,JX,KX,ITYPE,IMASK)
	 ENDIF
	ENDIF
       ENDIF
  200 CONTINUE
    
C  CHECK FOR END OF AVERAGING PERIOD AND ZERO TIME AVERAGES

      IF(MOD(IINT,IAVG).EQ.0) THEN
       DO 50 J=1,JM
       DO 50 I=1,IM
	UTM(I,J)=0.
	VTM(I,J)=0.
   50  CONTINUE
    
       DO 51 K=1,KB
       DO 51 J=1,JM
       DO 51 I=1,IM
	UM(I,J,K)=0.
	VM(I,J,K)=0.
   51  CONTINUE
      ENDIF 
      RETURN
      END

      SUBROUTINE OUT2(ID,N,A2D,I,J,ITYPE,IMASK)
      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'
      
      REAL A2D(IM,JM)
      NLUN=IJKOUT(7,N)
      
C WRITE FULL 2-D ARRAYS  

      IF(ITYPE.EQ.2) THEN
       IF(IMASK.EQ.1) CALL WXDR2(NLUN,A2D,FSM,IM,IM,JM,NFSM)
       IF(IMASK.EQ.2) CALL WXDR2(NLUN,A2D,DUM,IM,IM,JM,NDUM)
       IF(IMASK.EQ.3) CALL WXDR2(NLUN,A2D,DVM,IM,IM,JM,NDVM)
 
      ELSE

C  WRITE TIME SERIES OF 2D PARAMETER

       CALL XDRFLOAT(NLUN,A2D(I,J))

      ENDIF
      RETURN
      END

      SUBROUTINE OUT3(ID,N,A3D,IX,JX,KX,ITYPE,IMASK)
      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'
      REAL A3D(IM,JM,KB)
      REAL ISLICE(JM,KB),JSLICE(IM,KB),KSLICE(IM,JM)
	
      NLUN=IJKOUT(7,N)
      
C WRITE FULL 3-D ARRAYS  

      IF(ITYPE.EQ.3) THEN
       DO 30 K=1,KB
	IF(IMASK.EQ.1) CALL WXDR2(NLUN,A3D(1,1,K),FSM,IM,IM,JM,NFSM)
	IF(IMASK.EQ.2) CALL WXDR2(NLUN,A3D(1,1,K),DUM,IM,IM,JM,NDUM)
	IF(IMASK.EQ.3) CALL WXDR2(NLUN,A3D(1,1,K),DVM,IM,IM,JM,NDVM)
30     CONTINUE
      ENDIF

C  WRITE I SLICE

      IF(ITYPE.EQ.5) THEN
       DO 40 J=1,JM
       DO 40 K=1,KB
	ISLICE(J,K)=A3D(IX,J,K)
   40  CONTINUE
      CALL XDRARRAY_FLOAT(NLUN,ISLICE,JM*KB)
      ENDIF

C  WRITE J SLICE

      IF(ITYPE.EQ.6) THEN
       DO 50 I=1,IM
       DO 50 K=1,KB
	JSLICE(I,K)=A3D(I,JX,K)
   50  CONTINUE
      CALL XDRARRAY_FLOAT(NLUN,JSLICE,IM*KB)
      ENDIF

C  WRITE K SLICE

      IF(ITYPE.EQ.7) THEN
       DO 60 I=1,IM
       DO 60 J=1,JM
	KSLICE(I,J)=A3D(I,J,KX)
   60  CONTINUE
      CALL XDRARRAY_FLOAT(NLUN,KSLICE,IM*JM)
      ENDIF

C  WRITE 2D K SLICE (MASKED DATA)

      IF(ITYPE.EQ.8) THEN

	K=IJKOUT(4,N)-100

	IF(IMASK.EQ.1) CALL WXDR2(NLUN,A3D(1,1,K),FSM,IM,IM,JM,NFSM)
	IF(IMASK.EQ.2) CALL WXDR2(NLUN,A3D(1,1,K),DUM,IM,IM,JM,NDUM)
	IF(IMASK.EQ.3) CALL WXDR2(NLUN,A3D(1,1,K),DVM,IM,IM,JM,NDVM)
      ENDIF

C  WRITE TIME SERIES OF 3D PARAMETER

      IF(ITYPE.EQ.4) THEN
       IF(KX.GT.0) THEN
	CALL XDRFLOAT(NLUN,A3D(IX,JX,KX))
       ELSE
	DO 70 K=1,KB
	 CALL XDRFLOAT(NLUN,A3D(IX,JX,K))
   70   CONTINUE
       ENDIF
      ENDIF        
      RETURN
      END

      SUBROUTINE PRNT3D(LUN, A, IDIM, JDIM, IMAX, JMAX, KMAX, 
     *   NFIX, SPVAL)
C
C Purpose:
C
C        To normalize and print a specified 2-d subsection of a 3-d array
C
C Algorithm:
C
C        The routine first determines which 2-d subsection of the array A
C   is going to be printed.  It then calculates the maximum absolute value
C   of data in that subsection of array A.  Only points for which A(I,J,K)
C   is not equal to SPVAL are considered.  It then finds the power of ten 
C   by which AMAX must be multilpied for it to lie between 100 and 1000.
C   The index value of the subsection and power of ten are printed,
C   followed by the normalized data, formatted as 3 digit integers.
C   Points at which A(I,J,K) is equal to SPVAL are masked by asterisks.
C   Data are output in blocks with the lower subscript decreasing down
C   and the higher subscript increasing across the page.  The number of
C   values printed across a page is an internal parameter in the subroutine.
C
C Arguments:
C
C   LUN   -  Logical unit number on which to print.
C   A     -  Three-dimensional array from which a 2-d subsection will be 
C            normalized and printed.
C   IDIM  -  First dimension of A in dimension statement of calling program.
C   JDIM  -  Second dimension of A in dimension statement of calling program.
C   IMAX  -  Maximum I value actually used in A or fixed value of I.
C   JMAX  -  Maximum J value actually used in A or fixed value of J.
C   KMAX  -  Maximum K value actually used in A or fixed value of K.
C   NFIX  -  Specifies which of the three subscripts will be held fixed
C            (1 = I, 2 = J, 3 = K).  
C   SPVAL -  Special masking value: only the A(I,J,K) which are not equal
C            to SPVAL are printed
C
      DIMENSION INTEG(30), A(IDIM,JDIM,*)
C
C  NCOL is the number of values to print across a page
C
      NCOL = 30
C
C  AMAX = maximum absolute value of 2-d subsection
C
      AMAX = 0.0
C
C  First subscript fixed
C
      IF (NFIX .EQ. 1) THEN
       DO 10 J = 1, JMAX
	DO 10 K = 1, KMAX
	  IF (A(IMAX,J,K) .EQ. SPVAL) GO TO 10
	  AMAX = AMAX1(AMAX,ABS(A(IMAX,J,K)))
   10 CONTINUE
C
C  Second subscript fixed
C
      ELSE IF (NFIX. EQ. 2) THEN
       DO 20 I = 1, IMAX
	DO 20 K = 1, KMAX
	  IF (A(I,JMAX,K) .EQ. SPVAL) GO TO 20
	  AMAX = AMAX1(AMAX,ABS(A(I,JMAX,K)))
   20 CONTINUE
C
C  Third subscript fixed
C
      ELSE IF (NFIX. EQ. 3) THEN
       DO 30 I = 1, IMAX
	DO 30 J = 1, JMAX
	  IF (A(I,J,KMAX) .EQ. SPVAL) GO TO 30
	  AMAX = AMAX1(AMAX,ABS(A(I,J,KMAX)))
   30 CONTINUE
      ENDIF
C
C  Now find the power of ten by which we must multiply AMAX
C  so that it falls between 100 and 1000.
C
      MP = 0
C
C  Check for zero
C
      IF (AMAX .EQ. 0) GO TO 40
C
C  Take base 10 logarithm of AMAX
C
      AP = ALOG10(AMAX)
C
C  If AMAX is greater than 1000, MP is negative
C
      IF (AP .GT. 3.) MP = -IFIX(AP - 2.)
C
C  If AMAX is less than 100, MP is positive
C
      IF (AP .LT. 2.) MP = IFIX(3. - AP)
   40 CONTINUE
C
C  Print the subsection
C
C  First subscript fixed
C
      IF (NFIX .EQ. 1) THEN
       I1 = 1
       II = (JMAX - 1) / NCOL + 1
       IRMDR = JMAX - NCOL * (II - 1)
       DO 70 L = 1, II
C
C  When L=JJ only print IRMDR values
C
	 IF (L .EQ. II) NCOL = IRMDR
C
C  Print the value of I and the power
C
	 WRITE (LUN,1010) IMAX, MP
	 I2 = I1 + NCOL - 1
	 DO 60 JJ = 1, KMAX
	  J = KMAX - JJ + 1
	  DO 50 I = I1, I2
	    I3 = 1 + I - I1
	    INTEG(I3) = -9999
	    IF (A(IMAX,I,J) .NE. SPVAL) INTEG(I3) = 
     1       INT(A(IMAX,I,J)*10.**MP + SIGN(0.5,A(IMAX,I,J)*10.**MP))
   50     CONTINUE
	  WRITE (LUN,1000) (INTEG(I),I=1,NCOL)
   60   CONTINUE
	I1 = I2 + 1
   70 CONTINUE
C
C  Second subscript fixed
C
      ELSE IF (NFIX .EQ. 2) THEN
       I1 = 1
       II = (IMAX - 1) / NCOL + 1
       IRMDR = IMAX - NCOL * (II - 1)
       DO 100 L = 1, II
C
C  When L=II only print IRMDR values
C
	 IF (L .EQ. II) NCOL = IRMDR
C
C  Print the value of J and the power
C
	 WRITE (LUN,1020) JMAX, MP
	 I2 = I1 + NCOL - 1
	 DO 90 JJ = 1, KMAX
	  J = KMAX - JJ + 1
	  DO 80 I = I1, I2
	    I3 = 1 + I - I1
	    INTEG(I3) = -9999
	    IF (A(I,JMAX,J) .NE. SPVAL) INTEG(I3) = 
     1       INT(A(I,JMAX,J)*10.**MP + SIGN(0.5,A(I,JMAX,J)*10.**MP))
   80     CONTINUE
	  WRITE (LUN,1000) (INTEG(I),I=1,NCOL)
   90   CONTINUE
	I1 = I2 + 1
  100 CONTINUE
C
C  Third subscript fixed
C
      ELSE IF (NFIX .EQ. 3) THEN
       I1 = 1
       II = (IMAX - 1) / NCOL + 1
       IRMDR = IMAX - NCOL * (II - 1)
       DO 130 L = 1, II
C
C  When L=II only print IRMDR values
C
	 IF (L .EQ. II) NCOL = IRMDR
C
C  Print the value of K and the power
C
	 WRITE (LUN,1030) KMAX, MP
	 I2 = I1 + NCOL - 1
	 DO 120 JJ = 1, JMAX
	  J = JMAX - JJ + 1
	  DO 110 I = I1, I2
	    I3 = 1 + I - I1
	    INTEG(I3) = -9999
	    IF (A(I,J,KMAX) .NE. SPVAL) INTEG(I3) = 
     1       INT(A(I,J,KMAX)*10.**MP + SIGN(0.5,A(I,J,KMAX)*10.**MP))
  110     CONTINUE
	  WRITE (LUN,1000) (INTEG(I),I=1,NCOL)
  120   CONTINUE
	I1 = I2 + 1
  130 CONTINUE
      ENDIF
      RETURN
 1000 FORMAT (' ', 30I4)
 1010 FORMAT ('0 I=',I3,', VALUES MULTIPLIED BY 10**', I3)
 1020 FORMAT ('0 J=',I3,', VALUES MULTIPLIED BY 10**', I3)
 1030 FORMAT ('0 K=',I3,', VALUES MULTIPLIED BY 10**', I3)
      END


      SUBROUTINE HYDROSTAT
      INCLUDE 'pomgl2007.h' 
C--------------------------------------------------------------------
C THIS SUBROUTINE PERFORMS A HYDROSTATIC CONSISTENCY
C CHECK FOR THE PRINCETON MODEL SET UP FOR A BATHYMETRY.
C THIS CHECK VERIFIES THAT THE DEPTH GRADIENT AND SIGMA
C SURFACE SLOPE ARE CONSISTENT WITH HYDROSTATIC STABILITY.
C THIS ENSURES THAT FOR THE HORIZONTAL GRID INTERVAL AND 
C VERTICAL SIGMA INTERVAL, THE SIGMA SURFACE IMMEDIATELY
C BELOW (ABOVE) A GIVEN SIGMA SURFACE REMAINS BELOW (ABOVE)
C THE GIVEN SIGMA SURFACE WITHIN A HORIZONTAL DISTANCE OF
C ONE GRID INTERVAL. THIS CRITERION IS BASED ON EQUATION (1)
C OF THE REFERENCE:  
C HANEY, R.L., 1991. ON THE PRESSURE GRADIENT FORCE OVER
C STEEP TOPOGRAPHY IN SIGMA COORDINATE OCEAN MODELS, 
C J. PHYS. OCEANOG., 21, 610-619.
C A VALUE OF RATIO GREATER THAN ONE INDICATES THAT THIS
C STABILITY CRITERION IS NOT MET.  
C--------------------------------------------------------
      REAL RATIO(IM,JM),R1(IM,JM),ZRATIO(KBM1)    
C
      DO 1 J=1,JM
      DO 1 I=1,IM
      RATIO(I,J)=0.0
      R1(I,J)=0.0
    1 CONTINUE
C
      DO 8 K=1,KBM1
      ZRATIO(K)=0.0
    8 CONTINUE 
C 
      WRITE(6,91)
   91 FORMAT(13X,' K        Z       ZZ          DZ          ZZ/DZ ',/) 
      DO 9 K=1,KBM1
      ZRATIO(K)=ABS(ZZ(K)/DZ(K)) 
      WRITE(6,92) K,Z(K),ZZ(K),DZ(K),ZRATIO(K)
    9 CONTINUE
   92 FORMAT(10X,I5,2X,F10.3,2X,F10.3,2X,F10.3,2X,F10.3)   
C 
      DO 2 J=1,JM
      DO 2 I=1,IM 
      IF(FSM(I,J).LT.0.1) GO TO 2
C DETERMINE THE LARGEST TOPOGRAPHIC GRADIENT IN X AND Y  
C NOT CALCULATING GRADIENTS EXTENDING INTO LAND POINTS  
      IF(FSM(I+1,J).LT.0.1) THEN
      X1=0.0
      ELSE
      X1=ABS(H(I+1,J)-H(I,J))
      ENDIF 
C
      IF(FSM(I-1,J).LT.0.1) THEN
      X2=0.0
      ELSE
      X2=ABS(H(I,J)-H(I-1,J))
      ENDIF
C
      IF(FSM(I,J+1).LT.0.1) THEN 
      Y1=0.0
      ELSE
      Y1=ABS(H(I,J+1)-H(I,J))
      ENDIF
C
      IF(FSM(I,J-1).LT.0.1) THEN
      Y2=0.0
      ELSE
      Y2=ABS(H(I,J)-H(I,J-1)) 
      ENDIF
C 
      GMAX=AMAX1(X1,X2,Y1,Y2)  
      R1(I,J)=GMAX/H(I,J)  
    2 CONTINUE
      CALL PRXY('DELTA-H/H',TIME,R1,IM,1,JM,1,0.0) 
C  
      DO 100 K=1,KBM1
C
      DO 5 J=1,JM
      DO 5 I=1,IM
      RATIO(I,J)=0.0
    5 CONTINUE   
C 
      DO 10 J=1,JM
      DO 10 I=1,IM
      IF(FSM(I,J).LT.0.1) GO TO 10
      RATIO(I,J)=R1(I,J)*ZRATIO(K)       
   10 CONTINUE    
C 
      WRITE(6,96) K
   96 FORMAT(10X,' LEVEL K = ',I5)  
      CALL PRXY('HYDRO STABILITY',TIME,RATIO,IM,1,JM,1,0.0) 
  100 CONTINUE
C
      RETURN
      END  
c-----------------------------------------------------------------
      SUBROUTINE TMAXMIN(TMAX,IMAX,JMAX,TMIN,IMIN,JMIN)
      INCLUDE 'pomgl2007.h' 
C THIS SECTION OF CODE FINDS THE MAX AND MIN TEMPERATURES AND THEIR  
C (I,J,K) LOCATIONS, PRINTS THEM TO THE STANDARD OUT, AND WRITES
C THEM TO FILE UNIT=43.  THE 10 DEGREES C IS ADDED BACK TO THESE
C TEMPERATURES BEFORE PRINTING. 
C
      TMAX=-9999.0
      TMIN=9999.0
C
      DO 4489 K=1,KBM1
      DO 4489 J=1,JM
      DO 4489 I=1,IM
      IF(FSM(I,J).LT.0.01) GO TO 4489
	IF(T(I,J,K).GE.TMAX) THEN
	   TMAX=T(I,J,K)
	   IMAX=I
	   JMAX=J
	   KMAX=K
	ENDIF
	IF(T(I,J,K).LE.TMIN) THEN
	   TMIN=T(I,J,K)
	   IMIN=I
	   JMIN=J
	   KMIN=K
	ENDIF
 4489 CONTINUE
C 
      TMAX=TMAX+TBIAS
      TMIN=TMIN+TBIAS 
C WRITE TO STANDARD OUT 
C      WRITE(6,4490) TIME,TMAX,IMAX,JMAX,KMAX
C 4490 FORMAT(10X,'TIME = ',F10.3,' TMAX = ',F10.3,
C     1' IMAX = ',I3,' JMAX = ',I3,' KMAX = ',I3) 
C      WRITE(6,4491) TIME,TMIN,IMIN,JMIN,KMIN
C 4491 FORMAT(10X,'TIME = ',F10.3,' TMIN = ',F10.3,
C     1' IMIN = ',I3,' JMIN = ',I3,' KMIN = ',I3) 
C 
C WRITE TO FILE UNIT=43 FOR PLOTTING 
C      WRITE(43,4492) TIME,TMAX,TMIN
C 4492 FORMAT(3(F12.4)) 
C
      RETURN
      END 

      SUBROUTINE DMAXMIN(DMAX,IMAX,JMAX,DMIN,IMIN,JMIN)
      INCLUDE 'pomgl2007.h' 
C THIS SECTION OF CODE FINDS THE MAX AND MIN TIME-DEPENDENT DEPTHS
C AND THEIR (I,J) LOCATIONS
C
      DMAX=-9999.0
      DMIN=9999.0
C
      DO 4495 J=1,JM
      DO 4495 I=1,IM
      IF(FSM(I,J).LT.0.01) GO TO 4495
	IF(D(I,J).GE.DMAX) THEN
	   DMAX=D(I,J)
	   IMAX=I
	   JMAX=J
	ENDIF
	IF(D(I,J).LE.DMIN) THEN
	   DMIN=D(I,J)
	   IMIN=I
	   JMIN=J
	ENDIF
 4495 CONTINUE
C 
      RETURN
      END 



C--------------------------------------------------------------------
      SUBROUTINE INITIALIZE
      INCLUDE 'pomgl2007.h'  
C--------------------------------------------------------------
C THIS SECTION OF CODE INITIALIZES TO ZERO ALL 
C ARRAYS IN THE COMMON BLOCK 'pomgl2007_20.h' AND IN 
C THE MAIN PROGRAM    
C---------------------------------------------------------------
C INITIALIZE THE ONE DIMENSIONAL VERTICAL ARRAYS IN COMMON/BLK1D/ 
      DO  K=1,KB
      DZR(K)=0.0
      Z(K)  =0.0
      ZZ(K) =0.0
      DZ(K) =0.0
      DZZ(K)=0.0
      ENDDO  
C---------------------------------------------------------------
C INITIALIZE THE TWO DIMENSIONAL ARRAYS IN COMMON/BLK2D/  
      DO  J=1,JM
      DO  I=1,IM
      H(I,J)        =0.0 
      DX(I,J)       =0.0
      DY(I,J)       =0.0
      D(I,J)        =0.0
      DT(I,J)       =0.0
      ART(I,J)      =0.0
      ARU(I,J)      =0.0
      ARV(I,J)      =0.0
      CBC(I,J)      =0.0
      ALON(I,J)     =0.0
      ALAT(I,J)     =0.0
      DUM(I,J)      =0.0
      DVM(I,J)      =0.0
      FSM(I,J)      =0.0
      COR(I,J)      =0.0
      WUSURF(I,J)   =0.0
      WVSURF(I,J)   =0.0
      WUBOT(I,J)    =0.0
      WVBOT(I,J)    =0.0
      WTSURF(I,J)   =0.0 
      WSSURF(I,J)   =0.0 
      TPS(I,J)      =0.0
      AAM2D(I,J)    =0.0
      UAF(I,J)      =0.0
      UA(I,J)       =0.0
      UAB(I,J)      =0.0  
      VAF(I,J)      =0.0
      VA(I,J)       =0.0
      VAB(I,J)      =0.0
      ELF(I,J)      =0.0
      EL(I,J)       =0.0
      ELB(I,J)      =0.0
      PSI(I,J)      =0.0
      ETF(I,J)      =0.0
      ET(I,J)       =0.0
      ETB(I,J)      =0.0
      FLUXUA(I,J)   =0.0
      FLUXVA(I,J)   =0.0
      EGF(I,J)      =0.0
      EGB(I,J)      =0.0 
      UTM(I,J)      =0.0
      VTM(I,J)      =0.0
      CICE(I,J)     =0.0
C 
      UTB(I,J)      =0.0
      VTB(I,J)      =0.0 
      UTF(I,J)      =0.0
      VTF(I,J)      =0.0 
      ADVUA(I,J)    =0.0
      ADVVA(I,J)    =0.0 
      drx2d(I,J)    =0.0
      dry2d(I,J)    =0.0
      adx2d(I,J)    =0.0
      ady2d(I,J)    =0.0
      TSURF(I,J)    =0.0
      SSURF(I,J)    =0.0 
      SWRAD(I,J)    =0.0  
      e_atmos(i,j)  =0.e0
      vfluxb(i,j)   =0.e0
      vfluxf(i,j)   =0.e0
      ENDDO
      ENDDO  
C------------------------------------------------------------------
C INITIALIZE THE THREE DIMENSIONAL ARRAYS IN COMMON/BLK3D/    
      DO  K=1,KB
      DO  J=1,JM
      DO  I=1,IM
      A(I,J,K)      =0.0
      C(I,J,K)      =0.0
      EE(I,J,K)     =0.0 
      GG(I,J,K)     =0.0 
      UF(I,J,K)     =0.0 
      VF(I,J,K)     =0.0
      KM(I,J,K)     =0.0
      KH(I,J,K)     =0.0  
      KQ(I,J,K)     =0.0  
      L(I,J,K)      =0.0
      Q2(I,J,K)     =0.0
      Q2B(I,J,K)    =0.0
      AAM(I,J,K)    =0.0
      Q2L(I,J,K)    =0.0 
      Q2LB(I,J,K)   =0.0 
      U(I,J,K)      =0.0
      UB(I,J,K)     =0.0
      W(I,J,K)      =0.0 
      V(I,J,K)      =0.0 
      VB(I,J,K)     =0.0 
      T(I,J,K)      =0.0 
      TB(I,J,K)     =0.0 
      S(I,J,K)      =0.0 
      SB(I,J,K)     =0.0 
      RHO(I,J,K)    =0.0 
      DTEF(I,J,K)   =0.0 
      RMEAN(I,J,K)  =0.0
      UM(I,J,K)     =0.0
      VM(I,J,K)     =0.0 
C   
      TMEAN(I,J,K)  =0.0
      SMEAN(I,J,K)  =0.0 
      DRHOX(I,J,K)  =0.0
      DRHOY(I,J,K)  =0.0  
      ADVX(I,J,K)   =0.0
      ADVY(I,J,K)   =0.0 
      ENDDO
      ENDDO
      ENDDO  
C---------------------------------------------------------------
C INITIALIZE THE ARRAYS IN COMMON/bdry/ 

      do i=1,im
	vabn(i)=0.e0
	vabs(i)=0.e0
	eln(i)=0.e0
	els(i)=0.e0
	do k=1,kb
	  vbn(i,k)=0.e0
	  vbs(i,k)=0.e0
	  tbn(i,k)=0.e0
	  tbs(i,k)=0.e0
	  sbn(i,k)=0.e0
	  sbs(i,k)=0.e0
	end do
      end do
C
      do j=1,jm
	uabe(j)=0.e0
	uabw(j)=0.e0
	ele(j)=0.e0
	elw(j)=0.e0
	do k=1,kb
	  ube(j,k)=0.e0
	  ubw(j,k)=0.e0
	  tbe(j,k)=0.e0
	  tbw(j,k)=0.e0
	  sbe(j,k)=0.e0
	  sbw(j,k)=0.e0
	end do
      end do

C---------------------------------------------------------------
C INITIALIZE THE TWO DIMENSIONAL ARRAYS IN COMMON/FLUXES/  
      DO  J=1,JM
      DO  I=1,IM
      LHF(I,J)      =0.0 
      SHF(I,J)      =0.0 
      LWR(I,J)      =0.0 
      ENDDO
      ENDDO  
C---------------------------------------------------------------
C INITIALIZE THE TWO DIMENSIONAL ARRAYS IN COMMON/FLX2/  
      DO  J=1,JM
      DO  I=1,IM
      TAUX1(I,J)    =0.0 
      TAUY1(I,J)    =0.0 
      TAUX2(I,J)    =0.0 
      TAUY2(I,J)    =0.0 
      SHFX1(I,J)    =0.0 
      SHFX2(I,J)    =0.0 
      SWFX1(I,J)    =0.0 
      SWFX2(I,J)    =0.0 
      LWFX1(I,J)    =0.0 
      LWFX2(I,J)    =0.0 
      HSFX1(I,J)    =0.0 
      HSFX2(I,J)    =0.0 
      HLFX1(I,J)    =0.0 
      HLFX2(I,J)    =0.0 
      ENDDO
      ENDDO  
C END OF SECTION OF CODE FOR INITIALIZATION  
C------------------------------------------------------------------
      RETURN
      END 

C------------------------------------------------------------------

      SUBROUTINE FLUX1
 
C-------------------------------------------------------------------------
C FLUX1 USES WIND AND TEMPERATURE FIELDS GENERATED
C BY PROGRAM INTERP.  IT ASSUMES THAT WIND AND TEMPERATURE FIELDS
C AT TIME INTERVAL DTWIND (IN HOURS) HAVE BEEN GENERATED AND ARE 
C STORED IN DIRECT ACCESS FILES LISTED BELOW.  IT RETURNS THE WIND
C STRESS COMPONENTS WUSURF AND WVSURF FOR GRID SQUARE (I,J) AT EACH  
C TIME STEP.  
C-------------------------------------------------------------------------
C NOTE:  XDR FORMAT FILES CONTAIN DATA ONLY FOR THOSE GRID POINTS 
C        ACTUALLY IN THE LAKE DOMAIN, WITH NON-ZERO ELEMENTS OF 
C        MASK ARRAYS FSM(I,J), DUM(I,J), OR DVM(I,J).  DATA IS  
C        STORED IN ORDER OF INCREASING I, INCREASING J, (AND
C        INCREASING K FOR 3-D FIELDS).  CONVERSION BETWEEN 2-D
C        AND 1-D ARRAYS IS DONE IN SUBROUTINES RXDR2D AND WXDR2. 
C-------------------------------------------------------------------------
C
C 
C  LOGICAL UNIT 10 : 
C    FILE 'FINPUT.wu' CONTAINS THE U COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C
C  LOGICAL UNIT 11 :
C    FILE 'FINPUT.wv' CONTAINS THE V COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 12 :
C    FILE 'FINPUT.at' CONTAINS THE ATMOSPHERIC TEMPERATURE 
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 13 : 
C    FILE 'FINPUT.wt' CONTAINS THE AVERAGE LAKE SURFACE TEMPERATURE
C                     (ASCII FORMAT)  
C
C  LOGICAL UNIT 14 : 
C    FILE 'FINPUT.dp' CONTAINS THE DEW POINT TEMPERATURE
C                     (XDR FORMAT, FSM MASK) 
C
C  LOGICAL UNIT 15 :
C    FILE 'FINPUT.cl' CONTAINS THE CLOUD COVER 
C                    (XDR FORMAT, FSM MASK)    
C 
C--------------------------------------------------------------------------
C        FOR MODE=2,4   FILES FINPUT.wu, FINPUT.wv, FINPUT.at, FINPUT.wt   
C                       READ BY SUBROUTINE FLUX1 AND USED TO CALCULATE  
C                       SURFACE WIND STRESS. FILES FINPUT.dp AND  
C                       FINPUT.cl ARE NOT USED.  
C        FOR MODE=3     FILES FINPUT.wu, FINPUT.wv, FINPUT.at, FINPUT.dp, 
C                       AND FINPUT.cl ARE READ BY SUBROUTINE FLUX1 AND  
C                       USED TO CALCULATE WIND STRESS AND SURFACE HEAT   
C                       FLUX. THE FILE FINPUT.wt IS NOT USED.  
C-------------------------------------------------------------------------
C MODIFICATION HISTORY:
C   BASED ON SUBROUTINE TAU FROM 2-D MODELING SYSTEM, D.SCHWAB, JAN 93
C   ADDED HEAT FLUX CALCULATIONS BASED ON OSU CODE, WPO, JAN 93  
C
C   MODIFIED FOR USE WITH GLFS ; D.WELSH ; 4/93. NOW ALWAYS USES DEW POINT
C   & CLOUD COVER GRIDDED FIELDS AND CALLS ROUTINE SOLAR TO CALC. HEAT FLUX.
C
C   NOW INTERPOLATES WIND STRESS COMPONENTS FROM T-POINTS TO U and V-POINTS, 
C   D.BELETSKY, 11/95.
C
C   MOMENTUM AND HEAT FLUXES ARE NOW STORED IN THE RESTART FILE TO ALOW FOR
C   SEAMLESS RESTART. THIS IS NEEDED BECAUSE FLUXES ARE CALCULATED ONLY AT
C   THE MET.DATA INPUT TIME STEPS AND INTERPOLATED FOR EACH INTERNAL TIME
C   STEP IN BETWEEN. THEREFORE, IN THE LEAPFROG TIME INTEGRATION, FLUXES
C   FROM THE PREVIOUS INTERNAL TIME STEP (n-1) IN THE BEGINNING OF A RESTART
C   MODEL RUN SHOULD BE OBTAINED FROM A PRECEEDING MODEL RUN.
C   D.BELETSKY, 07/2003.
C
C
C   CHANGES / ADDITIONS MADE AT THIS TIME ARE SHOWN THUS :
C              C++++++++++++++++++++++++++++++
C                  CHANGES/ADDITIONS HERE
C              C++++++++++++++++++++++++++++++
C-------------------------------------------------------------------------                            

      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'

      REAL UW(IM,JM),VW(IM,JM),TA(IM,JM)


      REAL TW(2400)
      REAL TDEW(IM,JM),CC(IM,JM)  
C
      SAVE IFIRST,ZWIND,NREC,N1,NRMAX,TW

      DATA IFIRST/0/
      DATA RHOAW /1.25E-3/

C  HEIGHT OF WIND FIELDS

      ZWIND=10.
C-----------------------------------------------------------------------
C ON FIRST TIME STEP OPEN REQUIRED INPUT DATA FILES
C AND SET PARAMETERS
C
      IF(IFIRST.EQ.0) THEN
C
C DTWIND (HOURS) IS AN INPUT PARAMETER READ FROM INPUT FILE  
C AT START OF MAIN PROGRAM AND IS IN COMMON BLOCK 
C 
       NRMAX=IHRS/IFIX(DTWIND)+1
       PRINT *,NRMAX

       K=INDEX(FINPUT,' ') 
       CALL XDRDE(10,FINPUT(1:K-1)//'.wu')
       CALL XDRDE(11,FINPUT(1:K-1)//'.wv')
       CALL XDRDE(12,FINPUT(1:K-1)//'.at')
       IF(MODE.EQ.3) THEN
	CALL XDRDE(14,FINPUT(1:K-1)//'.dp')
	CALL XDRDE(15,FINPUT(1:K-1)//'.cl') 
       ENDIF
 
       IF((MODE.EQ.2).OR.(MODE.EQ.4)) THEN 
	OPEN(UNIT=13,FORM='FORMATTED',STATUS='OLD',
     1   FILE=FINPUT(1:K-1)//'.wt')
	READ(13,'(F8.2)')(TW(I),I=1,NRMAX-1)
	CLOSE(13)
       ENDIF 

       NREC=0

       N1=0
       IFIRST=1

      ENDIF
C END OF SETTING PARAMETERS FOR FIRST TIME STEP  
C-----------------------------------------------------------------

C DETERMINE RECORD NUMBER AT BEGINNING OF INTERVAL

      N=IFIX(TIME/DTWIND)+1
      T1=(N-1)*DTWIND

C CHECK IF NEW FIELDS ARE REQUIRED

      IF(N.NE.N1) THEN
       N1=N

C FIRST TIME THROUGH GET STRESSES AT BEGINNING OF INTERVAL

       IF(N1.EQ.1.AND.nread.NE.1) THEN
	NREC=NREC+1
	CALL RXDR2D(10,UW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(11,VW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(12,TA,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	IF(MODE.EQ.3) THEN
	 CALL RXDR2D(14,TDEW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)     
	 CALL RXDR2D(15,CC,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	ENDIF

	DO 40 J=1,JM
	DO 40 I=1,IM
	 IF(FSM(I,J).NE.0.) THEN
	  SPD=SQRT(UW(I,J)**2+VW(I,J)**2)
	  IF(MODE.EQ.3) THEN
C           TWAT=TB(I,J,1)+TBIAS
	   TWAT=T(I,J,1)+TBIAS
	  ELSE
	   TWAT=TW(N1+NRSKIP)
	  ENDIF
	  TD=TA(I,J)-TWAT  
c          CALL UZL(SPD,ZWIND,TD,CD,CH,Z0,FL)
	  CALL UZL10(SPD,TD,CD,CH)
C          RHOAW=354.65E-3/(TA(I,J)+273.15) 
	  TAUX1(I,J)=-CD*RHOAW*SPD*UW(I,J)
	  TAUY1(I,J)=-CD*RHOAW*SPD*VW(I,J)
	  IF(MODE.EQ.3) CALL SOLAR(TA(I,J),TDEW(I,J),SPD,CC(I,J),
     1     TWAT,CH,SHFX1(I,J),SWFX1(I,J),LWFX1(I,J),HSFX1(I,J),
     2     HLFX1(I,J),CD,I,J)
	 ENDIF
40      CONTINUE
       ELSE

C  INCREMENT NREC FOR RESTART

       IF(N1.EQ.1) THEN
	NREC=NREC+1
       ELSE

C  OTHERWISE GET OLD FIELD FROM END OF INTERVAL

	DO 30 J=1,JM
	DO 30 I=1,IM
	 TAUX1(I,J)=TAUX2(I,J)
	 TAUY1(I,J)=TAUY2(I,J)
	 IF(MODE.EQ.3) THEN
	  SHFX1(I,J)=SHFX2(I,J)
	  SWFX1(I,J)=SWFX2(I,J)
	  LWFX1(I,J)=LWFX2(I,J)
	  HSFX1(I,J)=HSFX2(I,J)
	  HLFX1(I,J)=HLFX2(I,J)
	 ENDIF
30      CONTINUE

       ENDIF
       ENDIF

C  READ FIELDS AT END OF INTERVAL

       NREC=NREC+1
       IF(NREC.LE.NRMAX) THEN
	CALL RXDR2D(10,UW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(11,VW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(12,TA,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	IF(MODE.EQ.3) THEN
	 CALL RXDR2D(14,TDEW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	 CALL RXDR2D(15,CC,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	ENDIF
	NT=MIN(N1+1,NRMAX-1)
	DO 50 J=1,JM
	DO 50 I=1,IM
	 IF(FSM(I,J).NE.0.) THEN
	  SPD=SQRT(UW(I,J)**2+VW(I,J)**2)
	  IF(MODE.EQ.3) THEN
	   IF(N1.EQ.1.AND.nread.EQ.1) THEN
	    TWAT=TB(I,J,1)+TBIAS
	   ELSE
	    TWAT=T(I,J,1)+TBIAS
	   ENDIF
	  ELSE
	   TWAT=TW(N1+NRSKIP)
	  ENDIF
	  TD=TA(I,J)-TWAT  
c          CALL UZL(SPD,ZWIND,TD,CD,CH,Z0,FL)
	  CALL UZL10(SPD,TD,CD,CH)
C          RHOAW=354.65E-3/(TA(I,J)+273.15) 
	  TAUX2(I,J)=-CD*RHOAW*SPD*UW(I,J)
	  TAUY2(I,J)=-CD*RHOAW*SPD*VW(I,J)
	  IF(MODE.EQ.3) CALL SOLAR(TA(I,J),TDEW(I,J),SPD,CC(I,J),
     1     TWAT,CH,SHFX2(I,J),SWFX2(I,J),LWFX2(I,J),HSFX2(I,J),
     2     HLFX2(I,J),CD,I,J)
	 ENDIF
50      CONTINUE
       ENDIF
      ENDIF

C LINEARLY INTERPOLATE WIND STRESS COMPONENTS IN TIME AND TO U,V-POINTS


      WGT=(TIME-T1)/DTWIND
C      PRINT *,'FLUX1',N,NREC,WGT,TIME,T1,DTWIND,TAUX1(50,50),
C     1  TAUY1(50,50),TAUX2(50,50),TAUY2(50,50),SHFX1(50,50),SHFX2(50,50)
C      PRINT *,'FLUX1',N,NREC,WGT,TIME,T1,DTWIND,UW(50,50),
C     1  VW(50,50),TA(50,50),TB(50,50,1)

      DO 60 J=1,JM
      DO 60 I=2,IM
       IF(DUM(I,J).NE.0) THEN
	WUSURF(I,J)=0.5*((1.-WGT)*(TAUX1(I,J)+TAUX1(I-1,J))
     1     + WGT*(TAUX2(I,J)+TAUX2(I-1,J)))
      ENDIF
60    CONTINUE        
      DO 61 J=2,JM
      DO 61 I=1,IM
       IF(DVM(I,J).NE.0) THEN
	WVSURF(I,J)=0.5*((1.-WGT)*(TAUY1(I,J)+TAUY1(I,J-1))
     1     + WGT*(TAUY2(I,J)+TAUY2(I,J-1))) 
      ENDIF
61    CONTINUE

C LINEARLY INTERPOLATE HEAT FLUX COMPONENTS IN TIME

C CONVERT TOTAL HEAT FLUX AND SHORTWAVE RADIATION TO MODEL UNITS
C NOTE: WE DO NOT CONVERT LWR,LHF,AND SHF TO MODEL UNITS BECAUSE
C       WE NEED THEM ONLY AS OUTPUT 

      IF(MODE.EQ.3) THEN
	CONV=-1./(4186.*1000.*1.025)
	DO 62 J=1,JM
	DO 62 I=1,IM
	 IF(FSM(I,J).NE.0) THEN
	   WTSURF(I,J)=(1.-WGT)*CONV*SHFX1(I,J)+WGT*CONV*SHFX2(I,J)
	   SWRAD(I,J)=(1.-WGT)*CONV*SWFX1(I,J)+WGT*CONV*SWFX2(I,J)

	   LWR(I,J)=(1.-WGT)*LWFX1(I,J)+WGT*LWFX2(I,J)
	   LHF(I,J)=(1.-WGT)*HLFX1(I,J)+WGT*HLFX2(I,J)
	   SHF(I,J)=(1.-WGT)*HSFX1(I,J)+WGT*HSFX2(I,J)

	  ENDIF 
62      CONTINUE
      ENDIF

      RETURN
      END

      SUBROUTINE FLUX2
 
C-------------------------------------------------------------------------
C FLUX2 USES IDEALIZED WIND STRESS AND HEAT FLUX FIELDS GENERATED
C BY PROGRAM pomglflx.f.  IT ASSUMES THAT THESE FIELDS HAVE BEEN
C GENERATED AT TIME INTERVAL DTWIND (IN HOURS)  AND ARE 
C STORED IN DIRECT ACCESS FILES LISTED BELOW.  IT RETURNS THE WIND
C STRESS COMPONENTS WUSURF AND WVSURF FOR GRID SQUARE (I,J) AT EACH  
C TIME STEP.  
C-------------------------------------------------------------------------
C NOTE:  XDR FORMAT FILES CONTAIN DATA ONLY FOR THOSE GRID POINTS 
C        ACTUALLY IN THE LAKE DOMAIN, WITH NON-ZERO ELEMENTS OF 
C        MASK ARRAYS FSM(I,J), DUM(I,J), OR DVM(I,J).  DATA IS  
C        STORED IN ORDER OF INCREASING I, INCREASING J, (AND
C        INCREASING K FOR 3-D FIELDS).  CONVERSION BETWEEN 2-D
C        AND 1-D ARRAYS IS DONE IN SUBROUTINES RXDR2D AND WXDR2. 
C-------------------------------------------------------------------------
C
C 
C  LOGICAL UNIT 10 : 
C    FILE 'FINPUT.tx' CONTAINS THE X COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C
C  LOGICAL UNIT 11 :
C    FILE 'FINPUT.ty' CONTAINS THE Y COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 12 :
C    FILE 'FINPUT.hf' CONTAINS THE SURFACE HEAT FLUX 
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 13 : 
C    FILE 'FINPUT.swr' CONTAINS THE SHORT WAVE RADIATION
C                     (XDR FORMAT, FSM MASK)  
C
C--------------------------------------------------------------------------
C        FOR MODE=2,4   FILES FINPUT.tx and FINPUT.ty   
C                       READ BY SUBROUTINE FLUX2 AND USED TO SPECIFY  
C                       SURFACE WIND STRESS. FILES FINPUT.hf AND  
C                       FINPUT.swr ARE NOT USED.  
C        FOR MODE=3     FILES FINPUT.tx, FINPUT.ty, FINPUT.hf, 
C                       AND FINPUT.swr ARE READ BY SUBROUTINE FLUX2 AND  
C                       USED TO SPECIFY WIND STRESS AND SURFACE HEAT   
C                       FLUX.  
C-------------------------------------------------------------------------
C MODIFICATION HISTORY:
C
C              C++++++++++++++++++++++++++++++
C                  CHANGES/ADDITIONS HERE
C              C++++++++++++++++++++++++++++++
C-------------------------------------------------------------------------                            

      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'

      SAVE IFIRST,NREC,N1,NRMAX
C 

      DATA IFIRST/0/

C-----------------------------------------------------------------------
C ON FIRST TIME STEP OPEN REQUIRED INPUT DATA FILES
C AND SET PARAMETERS
C
      IF(IFIRST.EQ.0) THEN
C
C DTWIND (HOURS) IS AN INPUT PARAMETER READ FROM INPUT FILE  
C AT START OF MAIN PROGRAM AND IS IN COMMON BLOCK 
C 
       NRMAX=IHRS/IFIX(DTWIND)+1
       PRINT *,NRMAX

       K=INDEX(FINPUT,' ') 
       CALL XDRDE(10,FINPUT(1:K-1)//'.tx')
       CALL XDRDE(11,FINPUT(1:K-1)//'.ty')
       IF(MODE.EQ.3) THEN
	CALL XDRDE(12,FINPUT(1:K-1)//'.hf')
	CALL XDRDE(13,FINPUT(1:K-1)//'.swr') 
       ENDIF

       NREC=0
       N1=0
       IFIRST=1

      ENDIF
C END OF SETTING PARAMETERS FOR FIRST TIME STEP  
C-----------------------------------------------------------------

C DETERMINE RECORD NUMBER AT BEGINNING OF INTERVAL

      N=IFIX(TIME/DTWIND)+1
      T1=(N-1)*DTWIND

C CHECK IF NEW FIELDS ARE REQUIRED

      IF(N.NE.N1) THEN
       N1=N

C FIRST TIME THROUGH GET STRESSES AT BEGINNING OF INTERVAL

       IF(N1.EQ.1.AND.nread.NE.1) THEN
	NREC=NREC+1
	CALL RXDR2D(10,TAUX1,DUM,IM,IM,JM,NDUM,NREC+NRSKIP)
	CALL RXDR2D(11,TAUY1,DVM,IM,IM,JM,NDVM,NREC+NRSKIP)
	IF(MODE.EQ.3) THEN
	 CALL RXDR2D(12,SHFX1,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)    
	 CALL RXDR2D(13,SWFX1,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	ENDIF

       ELSE

C  INCREMENT NREC FOR RESTART

       IF(N1.EQ.1) THEN
	NREC=NREC+1
       ELSE

C  OTHERWISE GET OLD FIELD FROM END OF INTERVAL

	DO 30 J=1,JM
	DO 30 I=1,IM
	 TAUX1(I,J)=TAUX2(I,J)
	 TAUY1(I,J)=TAUY2(I,J)
	 IF(MODE.EQ.3) THEN
	  SHFX1(I,J)=SHFX2(I,J)
	  SWFX1(I,J)=SWFX2(I,J)
	 ENDIF
30      CONTINUE

       ENDIF
       ENDIF

C  READ FIELDS AT END OF INTERVAL

       NREC=NREC+1
       IF(NREC.LE.NRMAX) THEN
	CALL RXDR2D(10,TAUX2,DUM,IM,IM,JM,NDUM,NREC+NRSKIP)
	CALL RXDR2D(11,TAUY2,DVM,IM,IM,JM,NDVM,NREC+NRSKIP)
	IF(MODE.EQ.3) THEN
	 CALL RXDR2D(12,SHFX2,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	 CALL RXDR2D(13,SWFX2,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	ENDIF
	NT=MIN(N1+1,NRMAX-1)
       ENDIF
      ENDIF

C LINEARLY INTERPOLATE WIND STRESS COMPONENTS IN TIME

      WGT=(TIME-T1)/DTWIND
      DO 60 J=1,JM
      DO 60 I=1,IM
       IF(DUM(I,J).NE.0) THEN
	WUSURF(I,J)=(1.-WGT)*TAUX1(I,J)+WGT*TAUX2(I,J)
       ENDIF
60    CONTINUE
       DO 61 J=1,JM
       DO 61 I=1,IM
	IF(DVM(I,J).NE.0) THEN 
	 WVSURF(I,J)=(1.-WGT)*TAUY1(I,J)+WGT*TAUY2(I,J)
	ENDIF
61    CONTINUE

C LINEARLY INTERPOLATE HEAT FLUX COMPONENTS IN TIME
C CONVERT  TO MODEL UNITS

      IF(MODE.EQ.3) THEN
	CONV=-1./(4186.*1000.*1.025)
	DO 62 J=1,JM
	DO 62 I=1,IM
	 IF(FSM(I,J).NE.0) THEN
	   WTSURF(I,J)=(1.-WGT)*CONV*SHFX1(I,J)+WGT*CONV*SHFX2(I,J)
	   SWRAD(I,J)=(1.-WGT)*CONV*SWFX1(I,J)+WGT*CONV*SWFX2(I,J)
	  ENDIF 
62      CONTINUE
      ENDIF

      RETURN
      END

      SUBROUTINE FLUX3
 
C-------------------------------------------------------------------------
C FLUX3 USES WIND AND TEMPERATURE FIELDS GENERATED
C BY PROGRAM INTERP.  IT ASSUMES THAT WIND AND TEMPERATURE FIELDS
C AT TIME INTERVAL DTWIND (IN HOURS) HAVE BEEN GENERATED AND ARE 
C STORED IN DIRECT ACCESS FILES LISTED BELOW.  IT RETURNS THE WIND
C STRESS COMPONENTS WUSURF AND WVSURF FOR GRID SQUARE (I,J) AT EACH  
C TIME STEP. IT DOES NOT CALCULATE HEAT FLUXES AS FLUX1, BUT USES 
C GENERATED FIELDS STORED IN DIRECT ACCESS FILES LISTED BELOW.   
C-------------------------------------------------------------------------
C NOTE:  XDR FORMAT FILES CONTAIN DATA ONLY FOR THOSE GRID POINTS 
C        ACTUALLY IN THE LAKE DOMAIN, WITH NON-ZERO ELEMENTS OF 
C        MASK ARRAYS FSM(I,J), DUM(I,J), OR DVM(I,J).  DATA IS  
C        STORED IN ORDER OF INCREASING I, INCREASING J, (AND
C        INCREASING K FOR 3-D FIELDS).  CONVERSION BETWEEN 2-D
C        AND 1-D ARRAYS IS DONE IN SUBROUTINES RXDR2D AND WXDR2. 
C-------------------------------------------------------------------------
C
C 
C  LOGICAL UNIT 10 : 
C    FILE 'FINPUT.wu' CONTAINS THE U COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C
C  LOGICAL UNIT 11 :
C    FILE 'FINPUT.wv' CONTAINS THE V COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 12 :
C    FILE 'FINPUT.at' CONTAINS THE ATMOSPHERIC TEMPERATURE 
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 13 : 
C    FILE 'FINPUT.wt' CONTAINS THE AVERAGE LAKE SURFACE TEMPERATURE
C                     (ASCII FORMAT)  
C
C  LOGICAL UNIT 14 : 
C    FILE 'FINPUT.hf' CONTAINS THE SURFACE HEAT FLUX
C                     (XDR FORMAT, FSM MASK) 
C
C  LOGICAL UNIT 15 :
C    FILE 'FINPUT.swr' CONTAINS THE SHORT WAVE RADIATION 
C                     (XDR FORMAT, FSM MASK)    
C 
C--------------------------------------------------------------------------
C        FOR MODE=2,4   FILES FINPUT.wu, FINPUT.wv, FINPUT.at, FINPUT.wt   
C                       READ BY SUBROUTINE FLUX3 AND USED TO CALCULATE  
C                       SURFACE WIND STRESS. FILES FINPUT.hf AND  
C                       FINPUT.swr ARE NOT USED.  
C        FOR MODE=3     FILES FINPUT.wu, FINPUT.wv, AND FINPUT.at 
C                       ARE READ BY SUBROUTINE FLUX3 AND USED TO  
C                       CALCULATE WIND STRESS. FILES FINPUT.hf AND 
C                       FINPUT.swr ARE USED TO SPECIFY SURFACE HEAT   
C                       FLUX. THE FILE FINPUT.wt IS NOT USED.  
C-------------------------------------------------------------------------
C MODIFICATION HISTORY:
C
C   CHANGES / ADDITIONS MADE AT THIS TIME ARE SHOWN THUS :
C              C++++++++++++++++++++++++++++++
C                  CHANGES/ADDITIONS HERE
C              C++++++++++++++++++++++++++++++
C-------------------------------------------------------------------------      
		     

      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'

      REAL UW(IM,JM),VW(IM,JM),TA(IM,JM)
      REAL TW(2400)
C
      SAVE IFIRST,ZWIND,NREC,N1,NRMAX,TW
C 

      DATA IFIRST/0/
      DATA RHOAW /1.25E-3/

C  HEIGHT OF WIND FIELDS

      ZWIND=10.
C-----------------------------------------------------------------------
C ON FIRST TIME STEP OPEN REQUIRED INPUT DATA FILES
C AND SET PARAMETERS
C
      IF(IFIRST.EQ.0) THEN
C
C DTWIND (HOURS) IS AN INPUT PARAMETER READ FROM INPUT FILE  
C AT START OF MAIN PROGRAM AND IS IN COMMON BLOCK 
C 
       NRMAX=IHRS/IFIX(DTWIND)+1
       PRINT *,NRMAX

       K=INDEX(FINPUT,' ') 
       CALL XDRDE(10,FINPUT(1:K-1)//'.wu')
       CALL XDRDE(11,FINPUT(1:K-1)//'.wv')
       CALL XDRDE(12,FINPUT(1:K-1)//'.at')
       IF(MODE.EQ.3) THEN
	CALL XDRDE(14,FINPUT(1:K-1)//'.hf')
	CALL XDRDE(15,FINPUT(1:K-1)//'.swr') 
       ENDIF
 
       IF((MODE.EQ.2).OR.(MODE.EQ.4)) THEN 
	OPEN(UNIT=13,FORM='FORMATTED',STATUS='OLD',
     1   FILE=FINPUT(1:K-1)//'.wt')
	READ(13,'(F8.2)')(TW(I),I=1,NRMAX-1)
	CLOSE(13)
       ENDIF 

       NREC=0
       N1=0
       IFIRST=1

      ENDIF
C END OF SETTING PARAMETERS FOR FIRST TIME STEP  
C-----------------------------------------------------------------

C DETERMINE RECORD NUMBER AT BEGINNING OF INTERVAL

      N=IFIX(TIME/DTWIND)+1
      T1=(N-1)*DTWIND

C CHECK IF NEW FIELDS ARE REQUIRED

      IF(N.NE.N1) THEN
       N1=N

C FIRST TIME THROUGH GET STRESSES AT BEGINNING OF INTERVAL

       IF(N1.EQ.1.AND.nread.NE.1) THEN
	NREC=NREC+1
	CALL RXDR2D(10,UW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(11,VW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(12,TA,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	IF(MODE.EQ.3) THEN
	 CALL RXDR2D(14,SHFX1,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)    
	 CALL RXDR2D(15,SWFX1,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	ENDIF

	DO 40 J=1,JM
	DO 40 I=1,IM
	 IF(FSM(I,J).NE.0.) THEN
	  SPD=SQRT(UW(I,J)**2+VW(I,J)**2)
	  IF(MODE.EQ.3) THEN
C           TWAT=TB(I,J,1)+TBIAS
	   TWAT=T(I,J,1)+TBIAS
	  ELSE
	   TWAT=TW(N1+NRSKIP)
	  ENDIF
	  TD=TA(I,J)-TWAT  
c          CALL UZL(SPD,ZWIND,TD,CD,CH,Z0,FL)
	  CALL UZL10(SPD,TD,CD,CH)
C          RHOAW=354.65E-3/(TA(I,J)+273.15) 
	  TAUX1(I,J)=-CD*RHOAW*SPD*UW(I,J)
	  TAUY1(I,J)=-CD*RHOAW*SPD*VW(I,J)
	 ENDIF
40      CONTINUE
       ELSE

C  INCREMENT NREC FOR RESTART

       IF(N1.EQ.1) THEN
	NREC=NREC+1
       ELSE

C  OTHERWISE GET OLD FIELD FROM END OF INTERVAL

	DO 30 J=1,JM
	DO 30 I=1,IM
	 TAUX1(I,J)=TAUX2(I,J)
	 TAUY1(I,J)=TAUY2(I,J)
	 IF(MODE.EQ.3) THEN
	  SHFX1(I,J)=SHFX2(I,J)
	  SWFX1(I,J)=SWFX2(I,J)
	 ENDIF
30      CONTINUE

       ENDIF
       ENDIF

C  READ FIELDS AT END OF INTERVAL

       NREC=NREC+1
       IF(NREC.LE.NRMAX) THEN
	CALL RXDR2D(10,UW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(11,VW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(12,TA,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	IF(MODE.EQ.3) THEN
	 CALL RXDR2D(14,SHFX2,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	 CALL RXDR2D(15,SWFX2,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	ENDIF
	NT=MIN(N1+1,NRMAX-1)
	DO 50 J=1,JM
	DO 50 I=1,IM
	 IF(FSM(I,J).NE.0.) THEN
	  SPD=SQRT(UW(I,J)**2+VW(I,J)**2)
	  IF(MODE.EQ.3) THEN
	   IF(N1.EQ.1.AND.nread.EQ.1) THEN
	    TWAT=TB(I,J,1)+TBIAS
	   ELSE
	    TWAT=T(I,J,1)+TBIAS
	   ENDIF
	  ELSE
	   TWAT=TW(N1+NRSKIP)
	  ENDIF
	  TD=TA(I,J)-TWAT  
c          CALL UZL(SPD,ZWIND,TD,CD,CH,Z0,FL)
	  CALL UZL10(SPD,TD,CD,CH)
C          RHOAW=354.65E-3/(TA(I,J)+273.15) 
	  TAUX2(I,J)=-CD*RHOAW*SPD*UW(I,J)
	  TAUY2(I,J)=-CD*RHOAW*SPD*VW(I,J)
	 ENDIF
50      CONTINUE
       ENDIF
      ENDIF



C LINEARLY INTERPOLATE WIND STRESS COMPONENTS IN TIME AND TO U,V-POINTS

      WGT=(TIME-T1)/DTWIND
      DO 60 J=1,JM
      DO 60 I=2,IM
       IF(DUM(I,J).NE.0) THEN
	WUSURF(I,J)=0.5*((1.-WGT)*(TAUX1(I,J)+TAUX1(I-1,J))
     1     + WGT*(TAUX2(I,J)+TAUX2(I-1,J)))
      ENDIF
60    CONTINUE        
      DO 61 J=2,JM
      DO 61 I=1,IM
       IF(DVM(I,J).NE.0) THEN
	WVSURF(I,J)=0.5*((1.-WGT)*(TAUY1(I,J)+TAUY1(I,J-1))
     1     + WGT*(TAUY2(I,J)+TAUY2(I,J-1)))   
      ENDIF
61    CONTINUE

C LINEARLY INTERPOLATE HEAT FLUX COMPONENTS IN TIME
C CONVERT TO MODEL UNITS 

      IF(MODE.EQ.3) THEN
	CONV=-1./(4186.*1000.*1.025)
	DO 62 J=1,JM
	DO 62 I=1,IM
	 IF(FSM(I,J).NE.0) THEN
	   WTSURF(I,J)=(1.-WGT)*CONV*SHFX1(I,J)+WGT*CONV*SHFX2(I,J)
	   SWRAD(I,J)=(1.-WGT)*CONV*SWFX1(I,J)+WGT*CONV*SWFX2(I,J)
	  ENDIF 
62      CONTINUE
      ENDIF

      RETURN
      END


      SUBROUTINE FLUX4
 
C-------------------------------------------------------------------------
C FLUX4 SPECIFIES ZERO WIND STRESS AND HEAT FLUX FOR ADAPTATION TYPE PROBLEMS.
C-------------------------------------------------------------------------

C-------------------------------------------------------------------------
C MODIFICATION HISTORY:
C
C              C++++++++++++++++++++++++++++++
C                  CHANGES/ADDITIONS HERE
C              C++++++++++++++++++++++++++++++
C-------------------------------------------------------------------------                            

      INCLUDE 'pomgl2007.h'


C SPECIFY WIND STRESS COMPONENTS

      DO 60 J=1,JM
      DO 60 I=1,IM
       IF(DUM(I,J).NE.0) THEN
	WUSURF(I,J)=TAUX
       ENDIF
60    CONTINUE
       DO 61 J=1,JM
       DO 61 I=1,IM
	IF(DVM(I,J).NE.0) THEN 
	 WVSURF(I,J)=TAUY
	ENDIF
61    CONTINUE

C SPECIFY HEAT FLUX COMPONENTS

      IF(MODE.EQ.3) THEN
	DO 62 J=1,JM
	DO 62 I=1,IM
	 IF(FSM(I,J).NE.0) THEN
	   WTSURF(I,J)=0.
	   SWRAD(I,J)=0.
	  ENDIF 
62      CONTINUE
      ENDIF

      RETURN
      END



      SUBROUTINE FLUX5
 
C-------------------------------------------------------------------------
C FLUX5 USES WIND AND TEMPERATURE FIELDS GENERATED
C BY PROGRAM INTERP.  IT ASSUMES THAT WIND AND TEMPERATURE FIELDS
C AT TIME INTERVAL DTWIND (IN HOURS) HAVE BEEN GENERATED AND ARE 
C STORED IN DIRECT ACCESS FILES LISTED BELOW.  IT RETURNS THE WIND
C STRESS COMPONENTS WUSURF AND WVSURF FOR GRID SQUARE (I,J) AT EACH  
C TIME STEP. HEAT FLUXES ARE ZERO.
C-------------------------------------------------------------------------
C NOTE:  XDR FORMAT FILES CONTAIN DATA ONLY FOR THOSE GRID POINTS 
C        ACTUALLY IN THE LAKE DOMAIN, WITH NON-ZERO ELEMENTS OF 
C        MASK ARRAYS FSM(I,J), DUM(I,J), OR DVM(I,J).  DATA IS  
C        STORED IN ORDER OF INCREASING I, INCREASING J, (AND
C        INCREASING K FOR 3-D FIELDS).  CONVERSION BETWEEN 2-D
C        AND 1-D ARRAYS IS DONE IN SUBROUTINES RXDR2D AND WXDR2. 
C-------------------------------------------------------------------------
C
C 
C  LOGICAL UNIT 10 : 
C    FILE 'FINPUT.wu' CONTAINS THE U COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C
C  LOGICAL UNIT 11 :
C    FILE 'FINPUT.wv' CONTAINS THE V COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 12 :
C    FILE 'FINPUT.at' CONTAINS THE ATMOSPHERIC TEMPERATURE 
C                     (XDR FORMAT, FSM MASK)  
C 
C--------------------------------------------------------------------------
C    MODE=3 ONLY        FILES FINPUT.wu, FINPUT.wv, AND FINPUT.at 
C                       ARE READ BY SUBROUTINE FLUX5 AND USED TO  
C                       CALCULATE WIND STRESS. HEAT FLUX IS ZERO.
C                       IF NEUTRAL STRATIFICATION IS SPECIFIED
C                       (INEUTR.NE.0) FILE FINPUT.at is not used. 
C-------------------------------------------------------------------------
C MODIFICATION HISTORY:
C
C   CHANGES / ADDITIONS MADE AT THIS TIME ARE SHOWN THUS :
C              C++++++++++++++++++++++++++++++
C                  CHANGES/ADDITIONS HERE
C              C++++++++++++++++++++++++++++++
C-------------------------------------------------------------------------      
		     

      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'

      REAL UW(IM,JM),VW(IM,JM),TA(IM,JM)
C
      SAVE IFIRST,ZWIND,NREC,N1,NRMAX,TW
C 

      DATA IFIRST/0/
      DATA RHOAW /1.25E-3/

C  CHECK THE MODE USED

      IF(MODE.NE.3) THEN 
       WRITE(6,*) 'INCORRECT MODE - STOP'
       STOP
      ENDIF 


C  HEIGHT OF WIND FIELDS

      ZWIND=10.
C-----------------------------------------------------------------------
C ON FIRST TIME STEP OPEN REQUIRED INPUT DATA FILES
C AND SET PARAMETERS
C
      IF(IFIRST.EQ.0) THEN
C
C DTWIND (HOURS) IS AN INPUT PARAMETER READ FROM INPUT FILE  
C AT START OF MAIN PROGRAM AND IS IN COMMON BLOCK 
C 
       NRMAX=IHRS/IFIX(DTWIND)+1
       PRINT *,NRMAX

       K=INDEX(FINPUT,' ') 
       CALL XDRDE(10,FINPUT(1:K-1)//'.wu')
       CALL XDRDE(11,FINPUT(1:K-1)//'.wv')

       IF(INEUTR.EQ.0) THEN
	CALL XDRDE(12,FINPUT(1:K-1)//'.at')
       ELSE
	WRITE(6,*) '****NEUTRAL ATMOSPHERIC STRATIFICATION****'
       ENDIF
       
       NREC=0
       N1=0
       IFIRST=1

      ENDIF
C END OF SETTING PARAMETERS FOR FIRST TIME STEP  
C-----------------------------------------------------------------

C DETERMINE RECORD NUMBER AT BEGINNING OF INTERVAL

      N=IFIX(TIME/DTWIND)+1
      T1=(N-1)*DTWIND

C CHECK IF NEW FIELDS ARE REQUIRED

      IF(N.NE.N1) THEN
       N1=N

C FIRST TIME THROUGH GET STRESSES AT BEGINNING OF INTERVAL

       IF(N1.EQ.1.AND.nread.NE.1) THEN
	NREC=NREC+1
	CALL RXDR2D(10,UW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(11,VW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
       IF(INEUTR.EQ.0) THEN
	CALL RXDR2D(12,TA,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
       ENDIF

	DO 40 J=1,JM
	DO 40 I=1,IM
	 IF(FSM(I,J).NE.0.) THEN
	  SPD=SQRT(UW(I,J)**2+VW(I,J)**2)
	 IF(INEUTR.EQ.0) THEN 
	  TWAT=TB(I,J,1)+TBIAS
	  TD=TA(I,J)-TWAT  
	 ELSE
	  TD=0.
	 ENDIF
c          CALL UZL(SPD,ZWIND,TD,CD,CH,Z0,FL)
	  CALL UZL10(SPD,TD,CD,CH)
C          RHOAW=354.65E-3/(TA(I,J)+273.15) 
	  TAUX1(I,J)=-CD*RHOAW*SPD*UW(I,J)
	  TAUY1(I,J)=-CD*RHOAW*SPD*VW(I,J)
	 ENDIF
40      CONTINUE
       ELSE

C  INCREMENT NREC FOR RESTART

       IF(N1.EQ.1) THEN
	NREC=NREC+1
       ELSE

C  OTHERWISE GET OLD FIELD FROM END OF INTERVAL

	DO 30 J=1,JM
	DO 30 I=1,IM
	 TAUX1(I,J)=TAUX2(I,J)
	 TAUY1(I,J)=TAUY2(I,J)
30      CONTINUE

       ENDIF
       ENDIF

C  READ FIELDS AT END OF INTERVAL

       NREC=NREC+1
       IF(NREC.LE.NRMAX) THEN
	CALL RXDR2D(10,UW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(11,VW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
       IF(INEUTR.EQ.0) THEN
	CALL RXDR2D(12,TA,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
       ENDIF
	NT=MIN(N1+1,NRMAX-1)

	DO 50 J=1,JM
	DO 50 I=1,IM
	 IF(FSM(I,J).NE.0.) THEN
	  SPD=SQRT(UW(I,J)**2+VW(I,J)**2)
	 IF(INEUTR.EQ.0) THEN 
	 IF(N1.EQ.1.AND.nread.EQ.1) THEN 
	  TWAT=TB(I,J,1)+TBIAS
	 ELSE
	  TWAT=T(I,J,1)+TBIAS
	 ENDIF      
	  TD=TA(I,J)-TWAT  
	 ELSE
	  TD=0.
	 ENDIF
c          CALL UZL(SPD,ZWIND,TD,CD,CH,Z0,FL)
	  CALL UZL10(SPD,TD,CD,CH)
C          RHOAW=354.65E-3/(TA(I,J)+273.15) 
	  TAUX2(I,J)=-CD*RHOAW*SPD*UW(I,J)
	  TAUY2(I,J)=-CD*RHOAW*SPD*VW(I,J)
	 ENDIF
50      CONTINUE
       ENDIF
      ENDIF



C LINEARLY INTERPOLATE WIND STRESS COMPONENTS IN TIME AND TO U,V-POINTS

      WGT=(TIME-T1)/DTWIND
      DO 60 J=1,JM
      DO 60 I=2,IM
       IF(DUM(I,J).NE.0) THEN
	WUSURF(I,J)=0.5*((1.-WGT)*(TAUX1(I,J)+TAUX1(I-1,J))
     1     + WGT*(TAUX2(I,J)+TAUX2(I-1,J)))
      ENDIF
60    CONTINUE        
      DO 61 J=2,JM
      DO 61 I=1,IM
       IF(DVM(I,J).NE.0) THEN
	WVSURF(I,J)=0.5*((1.-WGT)*(TAUY1(I,J)+TAUY1(I,J-1))
     1     + WGT*(TAUY2(I,J)+TAUY2(I,J-1)))   
      ENDIF
61    CONTINUE


C SPECIFY HEAT FLUX COMPONENTS

      IF(MODE.EQ.3) THEN
	DO 62 J=1,JM
	DO 62 I=1,IM
	 IF(FSM(I,J).NE.0) THEN
	   WTSURF(I,J)=0.
	   SWRAD(I,J)=0.
	  ENDIF 
62      CONTINUE
      ENDIF

      RETURN
      END


C------------------------------------------------------------------

      SUBROUTINE FLUX6
 
C-------------------------------------------------------------------------
C FLUX6 USES METEOROLOGICAL FIELDS GENERATED BY PROGRAM INTERP AND
c ICE FIELDS GENERATED BY ICEGRID.PRO.  IT ASSUMES THAT FIELDS
C AT TIME INTERVAL DTWIND (IN HOURS) HAVE BEEN GENERATED AND ARE 
C STORED IN DIRECT ACCESS FILES LISTED BELOW.  IT RETURNS THE WIND
C STRESS COMPONENTS WUSURF AND WVSURF FOR GRID SQUARE (I,J) AT EACH  
C TIME STEP.  
C-------------------------------------------------------------------------
C NOTE:  XDR FORMAT FILES CONTAIN DATA ONLY FOR THOSE GRID POINTS 
C        ACTUALLY IN THE LAKE DOMAIN, WITH NON-ZERO ELEMENTS OF 
C        MASK ARRAYS FSM(I,J), DUM(I,J), OR DVM(I,J).  DATA IS  
C        STORED IN ORDER OF INCREASING I, INCREASING J, (AND
C        INCREASING K FOR 3-D FIELDS).  CONVERSION BETWEEN 2-D
C        AND 1-D ARRAYS IS DONE IN SUBROUTINES RXDR2D AND WXDR2. 
C-------------------------------------------------------------------------
C
C 
C  LOGICAL UNIT 10 : 
C    FILE 'FINPUT.wu' CONTAINS THE U COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C
C  LOGICAL UNIT 11 :
C    FILE 'FINPUT.wv' CONTAINS THE V COMPONENT OF WIND FORCING
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 12 :
C    FILE 'FINPUT.at' CONTAINS THE ATMOSPHERIC TEMPERATURE 
C                     (XDR FORMAT, FSM MASK)  
C 
C  LOGICAL UNIT 13 : 
C    FILE 'FINPUT.wt' CONTAINS THE AVERAGE LAKE SURFACE TEMPERATURE
C                     (ASCII FORMAT)  
C
C  LOGICAL UNIT 14 : 
C    FILE 'FINPUT.dp' CONTAINS THE DEW POINT TEMPERATURE
C                     (XDR FORMAT, FSM MASK) 
C
C  LOGICAL UNIT 15 :
C    FILE 'FINPUT.cl' CONTAINS THE CLOUD COVER 
C                    (XDR FORMAT, FSM MASK)    
C 
C  LOGICAL UNIT 16 :
C    FILE 'FINPUT.ice' CONTAINS THE ICE COVER 
C                    (XDR FORMAT, FSM MASK)    
C 
C--------------------------------------------------------------------------
C        FOR MODE=2,4   FILES FINPUT.wu, FINPUT.wv, FINPUT.at, FINPUT.wt   
C                       READ BY SUBROUTINE FLUX1 AND USED TO CALCULATE  
C                       SURFACE WIND STRESS. FILES FINPUT.dp AND  
C                       FINPUT.cl ARE NOT USED.  
C        FOR MODE=3     FILES FINPUT.wu, FINPUT.wv, FINPUT.at, FINPUT.dp, 
C                       AND FINPUT.cl ARE READ BY SUBROUTINE FLUX1 AND  
C                       USED TO CALCULATE WIND STRESS AND SURFACE HEAT   
C                       FLUX. THE FILE FINPUT.wt IS NOT USED.  
C-------------------------------------------------------------------------
C MODIFICATION HISTORY:
C   BASED ON SUBROUTINE TAU FROM 2-D MODELING SYSTEM, D.SCHWAB, JAN 93
C   ADDED HEAT FLUX CALCULATIONS BASED ON OSU CODE, WPO, JAN 93  
C
C   MODIFIED FOR USE WITH GLFS ; D.WELSH ; 4/93. NOW ALWAYS USES DEW POINT
C   & CLOUD COVER GRIDDED FIELDS AND CALLS ROUTINE SOLAR TO CALC. HEAT FLUX.
C
C   NOW INTERPOLATES WIND STRESS COMPONENTS FROM T-POINTS TO U and V-POINTS, 
C   D.BELETSKY, 11/95.
C
C   MOMENTUM AND HEAT FLUXES ARE NOW STORED IN THE RESTART FILE TO ALOW FOR
C   SEAMLESS RESTART. THIS IS NEEDED BECAUSE FLUXES ARE CALCULATED ONLY AT
C   THE MET.DATA INPUT TIME STEPS AND INTERPOLATED FOR EACH INTERNAL TIME
C   STEP IN BETWEEN. THEREFORE, IN THE LEAPFROG TIME INTEGRATION, FLUXES
C   FROM THE PREVIOUS INTERNAL TIME STEP (n-1) IN THE BEGINNING OF A RESTART
C   MODEL RUN SHOULD BE OBTAINED FROM A PRECEEDING MODEL RUN.
C   D.BELETSKY, 07/2003.
C
C
C   CHANGES / ADDITIONS MADE AT THIS TIME ARE SHOWN THUS :
C+++++++++++++++++++++++++++++++++++++++++++++++++++++
C  modified subroutine FLUX1 to include ice DJS 2/2005                  
C+++++++++++++++++++++++++++++++++++++++++++++++++++++
C-------------------------------------------------------------------------                            

      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'
      REAL UW(IM,JM),VW(IM,JM),TA(IM,JM)

      REAL TW(2400)
      REAL TDEW(IM,JM),CC(IM,JM)  
C
      SAVE IFIRST,ZWIND,NREC,N1,NRMAX,TW

      DATA IFIRST/0/
      DATA RHOAW /1.25E-3/

C  HEIGHT OF WIND FIELDS

      ZWIND=10.
C-----------------------------------------------------------------------
C ON FIRST TIME STEP OPEN REQUIRED INPUT DATA FILES
C AND SET PARAMETERS
C
      IF(IFIRST.EQ.0) THEN
C
C DTWIND (HOURS) IS AN INPUT PARAMETER READ FROM INPUT FILE  
C AT START OF MAIN PROGRAM AND IS IN COMMON BLOCK 
C 
       NRMAX=IHRS/IFIX(DTWIND)+1
       PRINT *,NRMAX
       print *, 'using flux6'
       
       K=INDEX(FINPUT,' ') 
       CALL XDRDE(10,FINPUT(1:K-1)//'.wu')
       CALL XDRDE(11,FINPUT(1:K-1)//'.wv')
       CALL XDRDE(12,FINPUT(1:K-1)//'.at')
       CALL XDRDE(16,FINPUT(1:K-1)//'.ice')
       IF(MODE.EQ.3) THEN
	CALL XDRDE(14,FINPUT(1:K-1)//'.dp')
	CALL XDRDE(15,FINPUT(1:K-1)//'.cl') 
       ENDIF
 
       IF((MODE.EQ.2).OR.(MODE.EQ.4)) THEN 
	OPEN(UNIT=13,FORM='FORMATTED',STATUS='OLD',
     1   FILE=FINPUT(1:K-1)//'.wt')
	READ(13,'(F8.2)')(TW(I),I=1,NRMAX-1)
	CLOSE(13)
       ENDIF 

       NREC=0

       N1=0
       IFIRST=1

      ENDIF
C END OF SETTING PARAMETERS FOR FIRST TIME STEP  
C-----------------------------------------------------------------

C DETERMINE RECORD NUMBER AT BEGINNING OF INTERVAL

      N=IFIX(TIME/DTWIND)+1
      T1=(N-1)*DTWIND

C CHECK IF NEW FIELDS ARE REQUIRED

      IF(N.NE.N1) THEN
       N1=N

C FIRST TIME THROUGH GET STRESSES AT BEGINNING OF INTERVAL

       IF(N1.EQ.1.AND.nread.NE.1) THEN
	NREC=NREC+1
	CALL RXDR2D(10,UW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(11,VW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(12,TA,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(16,CICE,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	IF(MODE.EQ.3) THEN
	 CALL RXDR2D(14,TDEW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)     
	 CALL RXDR2D(15,CC,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	ENDIF

	DO 40 J=1,JM
	DO 40 I=1,IM
	 IF(FSM(I,J).NE.0.) THEN
	  SPD=SQRT(UW(I,J)**2+VW(I,J)**2)
	  IF(MODE.EQ.3) THEN
C           TWAT=TB(I,J,1)+TBIAS
	   TWAT=T(I,J,1)+TBIAS
	  ELSE
	   TWAT=TW(N1+NRSKIP)
	  ENDIF
	  TD=TA(I,J)-TWAT  
c          CALL UZL(SPD,ZWIND,TD,CD,CH,Z0,FL)
	  CALL UZL10(SPD,TD,CD,CH)
C          RHOAW=354.65E-3/(TA(I,J)+273.15) 
	  R=1.-0.5*CICE(I,J)
c          if(CICE(I,J).lt.1.) print *, i,j,CICE(I,J),r
	  TAUX1(I,J)=-R*CD*RHOAW*SPD*UW(I,J)
	  TAUY1(I,J)=-R*CD*RHOAW*SPD*VW(I,J)
	  IF(MODE.EQ.3) CALL SOLAR(TA(I,J),TDEW(I,J),SPD,CC(I,J),
     1     TWAT,CH,SHFX1(I,J),SWFX1(I,J),LWFX1(I,J),HSFX1(I,J),
     2     HLFX1(I,J),CD,I,J)
	 ENDIF
40      CONTINUE
       ELSE

C  INCREMENT NREC FOR RESTART

       IF(N1.EQ.1) THEN
	NREC=NREC+1
       ELSE

C  OTHERWISE GET OLD FIELD FROM END OF INTERVAL

	DO 30 J=1,JM
	DO 30 I=1,IM
	 TAUX1(I,J)=TAUX2(I,J)
	 TAUY1(I,J)=TAUY2(I,J)
	 IF(MODE.EQ.3) THEN
	  SHFX1(I,J)=SHFX2(I,J)
	  SWFX1(I,J)=SWFX2(I,J)
	  LWFX1(I,J)=LWFX2(I,J)
	  HSFX1(I,J)=HSFX2(I,J)
	  HLFX1(I,J)=HLFX2(I,J)
	 ENDIF
30      CONTINUE

       ENDIF
       ENDIF

C  READ FIELDS AT END OF INTERVAL

       NREC=NREC+1
       IF(NREC.LE.NRMAX) THEN
	CALL RXDR2D(10,UW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(11,VW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(12,TA,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	CALL RXDR2D(16,CICE,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)      
	IF(MODE.EQ.3) THEN
	 CALL RXDR2D(14,TDEW,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	 CALL RXDR2D(15,CC,FSM,IM,IM,JM,NFSM,NREC+NRSKIP)
	ENDIF
	NT=MIN(N1+1,NRMAX-1)
	DO 50 J=1,JM
	DO 50 I=1,IM
	 IF(FSM(I,J).NE.0.) THEN
	  SPD=SQRT(UW(I,J)**2+VW(I,J)**2)
	  IF(MODE.EQ.3) THEN
	   IF(N1.EQ.1.AND.nread.EQ.1) THEN
	    TWAT=TB(I,J,1)+TBIAS
	   ELSE
	    TWAT=T(I,J,1)+TBIAS
	   ENDIF
	  ELSE
	   TWAT=TW(N1+NRSKIP)
	  ENDIF
	  TD=TA(I,J)-TWAT  
c          CALL UZL(SPD,ZWIND,TD,CD,CH,Z0,FL)
	  CALL UZL10(SPD,TD,CD,CH)
C          RHOAW=354.65E-3/(TA(I,J)+273.15) 
	  R=1.-0.5*CICE(I,J)
c          if(CICE(I,J).lt.1.) print *, i,j,CICE(I,J),r
	  TAUX2(I,J)=-R*CD*RHOAW*SPD*UW(I,J)
	  TAUY2(I,J)=-R*CD*RHOAW*SPD*VW(I,J)
	  IF(MODE.EQ.3) CALL SOLAR(TA(I,J),TDEW(I,J),SPD,CC(I,J),
     1     TWAT,CH,SHFX2(I,J),SWFX2(I,J),LWFX2(I,J),HSFX2(I,J),
     2     HLFX2(I,J),CD,I,J)
	 ENDIF
50      CONTINUE
       ENDIF
      ENDIF

C LINEARLY INTERPOLATE WIND STRESS COMPONENTS IN TIME AND TO U,V-POINTS


      WGT=(TIME-T1)/DTWIND
c      PRINT *,'FLUX6',N,NREC,WGT,TIME,T1,DTWIND,TAUX1(50,50),
c     1  TAUY1(50,50),TAUX2(50,50),TAUY2(50,50),SHFX1(50,50),SHFX2(50,50)
c      PRINT *,'FLUX6',N,NREC,WGT,TIME,T1,DTWIND,UW(50,50),
c     1  VW(50,50),TA(50,50),TB(50,50,1)

      DO 60 J=1,JM
      DO 60 I=2,IM
       IF(DUM(I,J).NE.0) THEN
	WUSURF(I,J)=0.5*((1.-WGT)*(TAUX1(I,J)+TAUX1(I-1,J))
     1     + WGT*(TAUX2(I,J)+TAUX2(I-1,J)))
      ENDIF
60    CONTINUE        
      DO 61 J=2,JM
      DO 61 I=1,IM
       IF(DVM(I,J).NE.0) THEN
	WVSURF(I,J)=0.5*((1.-WGT)*(TAUY1(I,J)+TAUY1(I,J-1))
     1     + WGT*(TAUY2(I,J)+TAUY2(I,J-1)))   
      ENDIF
61    CONTINUE

C LINEARLY INTERPOLATE HEAT FLUX COMPONENTS IN TIME

C CONVERT TOTAL HEAT FLUX AND SHORTWAVE RADIATION TO MODEL UNITS
C NOTE: WE DO NOT CONVERT LWR,LHF,AND SHF TO MODEL UNITS BECAUSE
C       WE NEED THEM ONLY AS OUTPUT 

      IF(MODE.EQ.3) THEN
	CONV=-1./(4186.*1000.*1.025)
	DO 62 J=1,JM
	DO 62 I=1,IM
	 IF(FSM(I,J).NE.0) THEN
	   WTSURF(I,J)=(1.-WGT)*CONV*SHFX1(I,J)+WGT*CONV*SHFX2(I,J)
	   SWRAD(I,J)=(1.-WGT)*CONV*SWFX1(I,J)+WGT*CONV*SWFX2(I,J)

	   LWR(I,J)=(1.-WGT)*LWFX1(I,J)+WGT*LWFX2(I,J)
	   LHF(I,J)=(1.-WGT)*HLFX1(I,J)+WGT*HLFX2(I,J)
	   SHF(I,J)=(1.-WGT)*HSFX1(I,J)+WGT*HSFX2(I,J)

	  ENDIF 
62      CONTINUE
      ENDIF

      RETURN
      END

      SUBROUTINE SOLAR(TA,DP,WS,CC,TWAT,CH,SURFLX,Q0,RLN,HS,HL,CD,I,J)
C
C++++++++++++++++++++++
C
C     SUBROUTINE SOLAR
C
C++++++++++++++++++++++
C
C
C. PURPOSE:    TO CALCULATE THE INSOLATION AND SURFACE HEAT FLUX
C              GIVEN THE AIR TEMPERATURE, WIND SPEED, DEW POINT OR
C              VAPOR PRESSURE, WATER TEMPERATURE, DRAG COEFFICIENTS, 
C              JULIAN DATE, AND CLOUD COVERAGE
C
C. ALGORITHMS: SENSIBLE AND LATENT HEAT FLUXES ARE CALCULATED FROM
C              BULK TRANSFER EQUATIONS.  LONGWAVE RADIATION LOSS
C              IS FROM WYRTKI (1965).
C              GLOBAL RADIATION IS FROM GUTTMAN AND MATTHEWS
C              (1979), IVANOFF (1977) AND COTTON (1979). 
C              GLOBAL RAD IS FROM 290 - 4000  
C              MMICRONS.  SOLAR ALBEDO IS FROM AUBERT AND RICHARDS (1981)
C              (P. 173).
C       
C. HISTORY:    ORIGINAL WRITTEN BY M.J.McCORMICK OF GLERL
C              ; MODIFIED FOR USE WITH GLFS BY D.WELSH OF OHIO STATE,1990
C              ; MODIFIED BY D.WELSH 4/93 FOR USE WITH NEW VERSION OF
C                  CIRCULATION MODEL. JD & IHR NOW IN CALL (CALLED BY
C                  TAU) ; MONTH NOW CALCULATED IN SOLAR ; LONGITUDE &
C                  LATITUDE NOW SET = PRINCETON MODEL'S ALON & ALAT ARRAYS.
C                  - THESE CHANGES / ADDITIONS ARE INDICATED THUS :
C
C                    C++++++++++++++++++++++++++++++++
C
C                         CHANGES/ADDITIONS HERE
C
C          4/97 DJS:   ADDED Q0,RLN,HS,AND HL AS RETURNED PARAMETERS
C
C                    C++++++++++++++++++++++++++++++++
C  
C. PARAMETERS:
C
C..          (ALL UNITS ARE MKS)
C... CP - SPECIFIC HEAT OF DRY AIR AT CONSTANT PRESSURE (J/(KG C))
C... CW - SPECIFIC HEAT OF WATER (J/(KG C))
C..  CP AND CW FROM BRUTSAERT (1982)
C... SIGMA - STEFAN-BOLZMANN CONSTANT (W/M**2)
C... SOLC - SOLAR CONSTANT (W/M**2) (FROHLICH, 1977)
C... TRANS - AVERAGE ANNUAL SOLAR TRANSMISSION (DECIMAL), (REMNANT
C...        THINKING, NO LONGER USED)
C... EXT1 - EXTINCTION COEFFICIENT FOR VISIBLE LIGHT IN WATER (1/M)
C... EXT2 - EXTINCTION COEFFICIENT FOR IR RADIATION IN WATER (1/M)
C..  SURFLX - SURFACE HEAT FLUX
C..  WS - WIND SPEED (M/S)
C..  TIME - HOURS SINCE BEGINNING OF FIRST YEAR
C..  DP - DEW POINT (DEG C)
C..  SC - CLOUD AMOUNT COVERING SKY (DECIMAL)
C..  RHOA - AIR DENSITY (KG/M**3)
C..  RHOW(T,Z) - WATER DENSITY AS A FUNCTION OF T, AND Z (KG/M**3)
C..  CH - BULK AERODYNAMIC COEFFICIENT FOR HEAT
C..  CD - "       "          "          "  MOMENTUM
C..  RAD - MEASURED GLOBAL RADIATION (W/M**2)
C..  MISS - NUMBER OF TIME STEPS RAD DATA ARE MISSING
C..  DEW - LOGICAL VARIABLE. IF .TRUE. THEN HUMIDITY UNITS ARE
C..        MBAR, OTHERWISE, DEW POINT TEMPERATURE.
C..  ES - ELLIPTICITY OF EARTH'S ORBIT
C..  ED - 1-(SQUARE OF ES)
C..  RM - TRUE SOLAR NOON
C..  SRCS - CLEAR SKY SOLAR RADIATION (COTTON, 1979)
C..  CLD - PERCENT TRANSMISSION OF SRCS DUE TO CLOUDS
C..  C'S ANS A'S - COEFFICIENTS DERIVED BY COTTON (1979)
C..                FOR USE IN HIS REGRESSION RELATION.
C.. N.B.  THESE JUST MENTIONED COEFFICIENTS ARE FOR MADISON,
C.. WISC. AND ARE USEFUL FOR HOURLY RADIATION (GLOBAL) ESTIMATES.
C..................................................................

      LOGICAL DEW
      DIMENSION IMON(12),A0(12,2),A1(2),A2(2),A3(2)
C
C+++++++++++++++++++++++++++++++
C
      INCLUDE 'pomgl2007.h'
C
C     COMMON /LOC/ SINLAT,COSLAT,MAXDEP,TRANS,EXT1,
C    + EXT2,Z(250),RLONG
C     COMMON /HEAD/ IHEAD(21),ITIME,IYR,JDB,INTER,NPTS,NDATA,NREC,
C    +JD,MONTH
C     COMMON /GPARM/ RPARM(23), IPARM(54)
C     COMMON /UNIT/ DEW
C     COMMON /SPACE/ DZ, DT
C     COMMON /GLOBAL/ RAD,MISS
C
C++++++++++++++++++++++++++++++++
C
      DATA CP, CW, SIGMA/1005., 4186., 5.6697E-08/
      DATA SOLC,PHASE,TWOPI/1375., .4583, 6.28319/
      DATA DEG/273.15/
      DATA ES, ED/0.0167238, .99986/
      DATA IMON/32,60,91,121,152,182,213,244,274,305,335,366/
      DATA A0/10., 37., 62., -6., -84., -157.,
     +        -180., -164., -103., -61., -12., 6.,
     +       -18., 10., 12., -56., -148., -217.,
     +       -222., -216., -178., -106., -59., -50./
      DATA A1/2460., 2550./
      DATA A2/3010., 2800./
      DATA A3/-1750., -1580./
      DATA C0,C1,C2,C3/.999, -.425, .922, -1.14/
C     DATA NBEGIN/0/
C
C CONVERT CLOUD COVER TO A DECIMAL
C
C      SC=CC/8.0
C***DJS 3/95*** CC ALREADY A DECIMAL
       SC=CC
C
      DEW=.FALSE.
      TWOPI=6.28318531
C     IF(NBEGIN .EQ. 0)THEN
C       MISS=0
C       RAD=-999.
C       NBEGIN=1
C     END IF
c+++++++++++
c     SST=T
      SST=TWAT
c+++++++++++
      TAK=TA + DEG
      DPK=DP + DEG
      TWK=SST + DEG
C.
C.. CALCULATE LATENT HEAT OF VAPORIZATION
C.
      RHLAT=(2.501-.00236*SST)*1.E+06
      RHOA=354.65/TAK
      ETW=VAP(TWK)
      IF(DEW) THEN
      EDP=DP
      ELSE
      EDP=VAP(DPK)
      END IF
C.
C.. CALCULATE SPECIFIC HUMIDITY AT WATER SURFACE AND AT INSTRUMENT
C.. HEIGHT
C.
      QW=.622*ETW/(1018.-.378*ETW)
      QA=.622*EDP/(1018.-.378*EDP)
C.
C.. CALCULATE LATENT HEAT LOSS
C.
      HL=-CD*RHOA*RHLAT*WS*(QW-QA)
C.
C.. CALCULATE SENSIBLE HEAT LOSS
C.
      HS=-CH*CP*RHOA*WS*(SST-TA)
C.
C.. CALCULATE LONGWAVE RADIATION LOSS
C.
      RLN=-SIGMA*TWK*TWK*TWK*TWK*(0.39-.05*SQRT(VAP(TAK)))*
     +(1.-.67*SC*SC) - 4.*SIGMA*TWK*TWK*TWK*(SST-TA)
C.
C.. SHORT WAVE GLOBAL RADIATION
C.. CALCULATE COSINE OF ZENITH ANGLE, CST
C.. THETA = SUN'S DECLINATION, HR = LOCAL HOUR ANGLE
C.
C
C++++++++++++++++++++++++++++++++++
C
C   GMT = GMT HOUR OF DDAY
C     GMT=FLOAT(ITIME)
C
      JD=IJD0
      GMT=FLOAT(IHR0)
C.
      DAY=FLOAT(JD)
      IF(JD.LE.31)MONTH=1
      IF((JD.GT.31).AND.(JD.LE.59))MONTH=2
      IF((JD.GT.59).AND.(JD.LE.90))MONTH=3
      IF((JD.GT.90).AND.(JD.LE.120))MONTH=4
      IF((JD.GT.120).AND.(JD.LE.151))MONTH=5
      IF((JD.GT.151).AND.(JD.LE.181))MONTH=6
      IF((JD.GT.181).AND.(JD.LE.212))MONTH=7
      IF((JD.GT.212).AND.(JD.LE.243))MONTH=8
      IF((JD.GT.243).AND.(JD.LE.273))MONTH=9
      IF((JD.GT.273).AND.(JD.LE.304))MONTH=10
      IF((JD.GT.304).AND.(JD.LE.334))MONTH=11
      IF(JD.GT.334)MONTH=12
C
C++++++++++++++++++++++++++++++++++
C
C..CHANGED FROM VAX VERSION SO THAT ANGLES ARE NOW IN RADIANS
      ANGD=TWOPI*(DAY-1.)/365.242
      SIG=279.9348+1.914827*SIN(ANGD) - 0.079525*COS(ANGD)
     + +0.01993*SIN(2.*ANGD)-0.00162*COS(2.*ANGD) + ANGD*360./TWOPI
      SIG=SIG*TWOPI/360.
      STHETA=SIN(0.4091722)*SIN(SIG)
      ARCS=ASIN(STHETA)
      CTHETA=COS(ARCS)
      RM=12.+(0.12357*SIN(ANGD)-0.004289*COS(ANGD)+0.153809*
     + SIN(2.*ANGD)+.060783*COS(2.*ANGD))
C
C++++++++++++++++++++++++++++++
C
      XM=(I-0.5)*RPARM(3)
      YM=(J-0.5)*RPARM(3)
      RLONG=RLON(XM,YM)
C      RLONG=ALON(I,J)
      HRANG=15.*(GMT-RM) - RLONG
      HRANG=HRANG*TWOPI/360.
C
      RLATD=RLAT(XM,YM)
C      RLATI=ALAT(I,J)
      SINLAT=SIN(RLATD*TWOPI/360.0)
      COSLAT=COS(RLATD*TWOPI/360.0)
C      SINLAT=SIN(RLATI*TWOPI/360.0)
C      COSLAT=COS(RLATI*TWOPI/360.0)
C
C++++++++++++++++++++++++++++++++++++++++
C
      CST=SINLAT*STHETA+COSLAT*CTHETA*COS(HRANG)
      SOL=SOLC*((1.+ES*COS(ANGD))/ED)**2
C
      Q0=0.
      srcs=0.0
      cld=0.0
C.
C.. IF SUN IS BELOW HORIZON OR ALBEDO IS GREATER THAN 1, Q = 0.
C.
C.. CHECK IF MEASURED OR MODELED RADIATION DATA ARE AVAILABLE.
C.. IF DATA ARE AVAILABLE USE IN PLACE OF PRESENT ALGORITHM.
C.
C     IF(RAD .NE. -999.) GOTO 30
C     MISS=MISS+1
      IF(CST .LE. 0.) GOTO 30
      ALB=.045/CST
      ALBEDO=0.
      IF(ALB .GT. 1.) ALBEDO=1.
C.
C.  
      CLD=C0 +C1*SC +C2*SC*SC +C3*SC*SC*SC
      M=MONTH
      N=1
      IF(RM .GT. 12.) N=2
      SRCS=A0(M,N) +A1(N)*CST +A2(N)*CST*CST +A3(N)*CST*CST*CST
c
      if(srcs.lt.0.0)srcs=0.0
C.
C..CONVERT FROM KJ/HR TO W/M**2 AND INCLUDE ALBEDO
C.
      Q0=SRCS*CLD*(1.-ALBEDO)/3.6
C.
 30   CONTINUE
C     IF(RAD .NE. -999.) Q0=RAD
C.
C.
      SURFLX=HS+HL+RLN+Q0

      RETURN
      END

      FUNCTION VAP(T)
C.
C.. FUNCTION CALCULATES SATURATION VAPOR PRESSURE IN MB.
C.. ALGORITHM FROM FLEAGLE AND BUSINGER (1980) P. 72.
C.  'T' IS IN DEGREES KELVIN
C.
      VAP=.01*EXP(26.25 - 5418./T)
C.
      RETURN
      END

C--------------------------------------------------------------------
      SUBROUTINE RSTART(I)

C  SUBROUTINE TO READ OR WRITE A RESTART FILE IN XDR FORMAT

C   INPUT PARAMETER: I=0 FOR READ  (FILE FINIT)
C                    I=1 FOR WRITE (FILE .rst  - regular  restart file)
C                    I=2 FOR WRITE (FILE .mrst - multiple restart file)

      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'    
      SAVE IFIRST
C
      DATA IFIRST/1/

       IF(I.EQ.0) CALL XDRDE(1,FINIT)

       IF(I.EQ.1) THEN
	K=INDEX(FOUT,' ')
	WRITE(6,*) 'WRITING RESTART FILE:'
	FNAME=FOUT(1:K-1)//'.rst '
	WRITE(6,'(1X,A)') FNAME
	CALL XDREN(1,FNAME)
       ENDIF
      
C--------------------------------------------------------------------
C OPEN MULTIPLE XDR RESTART FILE 

       IF(I.EQ.2) THEN
	IF(IFIRST.EQ.1) THEN
	 K=INDEX(FOUT,' ')
	 WRITE(6,*) 'WRITING MULTIPLE RESTART FILE:'
	 FNAME=FOUT(1:K-1)//'.mrst '
	 WRITE(6,'(1X,A)') FNAME
	 CALL XDREN(1,FNAME)
	ENDIF
       IFIRST=0
       ENDIF


       LIJ1=LIJ
       LIJK1=LIJK

C  2D ARRAYS

       CALL XDRARRAY_FLOAT(1,WUBOT,LIJ1)
       CALL XDRARRAY_FLOAT(1,WVBOT,LIJ1)
       CALL XDRARRAY_FLOAT(1,AAM2D,LIJ1)
       CALL XDRARRAY_FLOAT(1,UA,LIJ1)
       CALL XDRARRAY_FLOAT(1,UAB,LIJ1)
       CALL XDRARRAY_FLOAT(1,VA,LIJ1)
       CALL XDRARRAY_FLOAT(1,VAB,LIJ1)
       CALL XDRARRAY_FLOAT(1,EL,LIJ1)
       CALL XDRARRAY_FLOAT(1,ELB,LIJ1)
       CALL XDRARRAY_FLOAT(1,ET,LIJ1)
       CALL XDRARRAY_FLOAT(1,ETB,LIJ1)
       CALL XDRARRAY_FLOAT(1,EGB,LIJ1)
       CALL XDRARRAY_FLOAT(1,UTB,LIJ1)
       CALL XDRARRAY_FLOAT(1,VTB,LIJ1)
       CALL XDRARRAY_FLOAT(1,adx2d,LIJ1)
       CALL XDRARRAY_FLOAT(1,ady2d,LIJ1)
       CALL XDRARRAY_FLOAT(1,ADVUA,LIJ1)
       CALL XDRARRAY_FLOAT(1,ADVVA,LIJ1)
       
       CALL XDRARRAY_FLOAT(1,TAUX1,LIJ1)
       CALL XDRARRAY_FLOAT(1,TAUY1,LIJ1)
       CALL XDRARRAY_FLOAT(1,SHFX1,LIJ1)
       CALL XDRARRAY_FLOAT(1,SWFX1,LIJ1)
       CALL XDRARRAY_FLOAT(1,LWFX1,LIJ1)
       CALL XDRARRAY_FLOAT(1,HSFX1,LIJ1)
       CALL XDRARRAY_FLOAT(1,HLFX1,LIJ1)

C  3D ARRAYS

       CALL XDRARRAY_FLOAT(1,U,LIJK1)
       CALL XDRARRAY_FLOAT(1,UB,LIJK1)
       CALL XDRARRAY_FLOAT(1,V,LIJK1)
       CALL XDRARRAY_FLOAT(1,VB,LIJK1)
       CALL XDRARRAY_FLOAT(1,W,LIJK1)
       CALL XDRARRAY_FLOAT(1,T,LIJK1)
       CALL XDRARRAY_FLOAT(1,TB,LIJK1)
       CALL XDRARRAY_FLOAT(1,S,LIJK1)
       CALL XDRARRAY_FLOAT(1,SB,LIJK1)
       CALL XDRARRAY_FLOAT(1,RHO,LIJK1)
       CALL XDRARRAY_FLOAT(1,KM,LIJK1)
       CALL XDRARRAY_FLOAT(1,KH,LIJK1)
       CALL XDRARRAY_FLOAT(1,KQ,LIJK1)
       CALL XDRARRAY_FLOAT(1,L,LIJK1)
       CALL XDRARRAY_FLOAT(1,Q2,LIJK1)
       CALL XDRARRAY_FLOAT(1,Q2B,LIJK1)
       CALL XDRARRAY_FLOAT(1,AAM,LIJK1)
       CALL XDRARRAY_FLOAT(1,Q2L,LIJK1)
       CALL XDRARRAY_FLOAT(1,Q2LB,LIJK1)
       CALL XDRARRAY_FLOAT(1,TMEAN,LIJK1)
       CALL XDRARRAY_FLOAT(1,SMEAN,LIJK1)

       IF(I.NE.2) CALL XDRCLOSE(1)

      RETURN 
      END

      SUBROUTINE RMSVAL(RMSV,RMSVV,RMSE,TAVG,TDEVS)
C
C Purpose:
C     Calculate the following quantities:
C       1) RMS horizontal velocity
C       1) RMS vertical velocity
C       1) RMS water level elevation
C       3) Average temperature
C       4) 2dx noise in surface temperature 
C
C Based on subroutine HCTKE by CKuan and JKelley, OSU 1993
C  -----------------------------------------------------------------------

      INCLUDE 'pomgl2007.h'
      save
      
      VSUM  = 0.
      VVSUM = 0.
      VOLSUM = 0.
      ESUM  = 0.
      TSUM = 0.

      DO J=1,JM
	DO I=1,IM
	  IF(FSM(I,J) .NE. 0) THEN
	    ESUM=ESUM+EL(I,J)*EL(I,J)
	    DO K=1,KBM1

C  Calculate volume of grid box and basin

	      VOLGRD = H(I,J)*DZ(K)*DS*DS                !Units: m**3
	      VOLSUM = VOLSUM + VOLGRD

C  Calculate mean u,v,and w velocities for each grid box

	      WGRD   = (W(I,J,K)+W(I,J,K+1))/2.
	      VGRD   = (V(I,J,K)+V(I,J+1,K))/2.
	      UGRD   = (U(I,J,K)+U(I+1,J,K))/2.

C  Add to totals

	      VSUM=VSUM+VOLGRD*(UGRD*UGRD+VGRD*VGRD)
	      VVSUM=VVSUM+VOLGRD*WGRD*WGRD
	      TSUM=TSUM+VOLGRD*T(I,J,K)
	    ENDDO
	  ENDIF
	ENDDO
      ENDDO

C  Calculate RMS values

      RMSV=SQRT(VSUM/VOLSUM)
      RMSVV=SQRT(VVSUM/VOLSUM)
      RMSE=SQRT(ESUM/FLOAT(NFSM))
      TAVG=TSUM/VOLSUM+TBIAS

C  Calculate 2dx noise

      TDEVS=0.

      DO J=2,JMM1
      DO I=2,IMM1
       IF(FSM(I,J) .NE. 0) THEN
	 TDEV=0.
	 DENOM=0.

	 IF(FSM(I+1,J).NE.0) THEN
	   TDEV=TDEV+T(I+1,J,1)
	   DENOM=DENOM+1
	 ENDIF

	 IF(FSM(I,J+1).NE.0) THEN
	   TDEV=TDEV+T(I,J+1,1)
	   DENOM=DENOM+1
	 ENDIF

	 IF(FSM(I-1,J).NE.0) THEN
	   TDEV=TDEV+T(I-1,J,1)
	   DENOM=DENOM+1
	 ENDIF

	 IF(FSM(I,J-1).NE.0) THEN
	   TDEV=TDEV+T(I,J-1,1)
	   DENOM=DENOM+1
	 ENDIF
       
       TDEV=TDEV/DENOM
       TDEVS=TDEVS+(T(I,J,1)-TDEV)**2
       
       ENDIF
      ENDDO
      ENDDO

      TDEVS=SQRT(TDEVS/NFSM)
      
      RETURN
      END

C----------------------------------------------------------------------
      SUBROUTINE TZAVG
      
C  CALCULATE HORIZONTALLY AVERAGED TEMPERATURE PROFILE AND REINTERPOLATE TO
C   SIGMA LEVELS.  TZ IS CALCULATED AT 1 M INCREMENTS STARTING AT 0.5 M.

      INCLUDE 'pomgl2007.h'
      INCLUDE 'lahey.f'
      SAVE IFIRST,NTZ
      DATA IFIRST /0/
      DIMENSION TZ(1000),WTZ(1000)

C  FIRST TIME THROUGH, OPEN OUTPUT FILE '.tmz'

      IF(IFIRST.EQ.0) THEN
       K=INDEX(FOUT,' ')
       CALL XDREN(19,FOUT(1:K-1)//'.tmz')
       IFIRST=1
       NTZ=IFIX(DEPMAX+DADD)
      ENDIF
      
      DO 5 N=1,NTZ
       TZ(N)=0.
       WTZ(N)=0.
    5 CONTINUE
	  
C  FIND AVERAGE TEMPERATURE PROFILE AT 1 METER Z-LEVELS

      DO 50 J=1,JM
      DO 50 I=1,IM
       
       IF(FSM(I,J).NE.1) GO TO 50
       K=2
       ND=IFIX(H(I,J))
       DO 40 N=1,ND
       
C USE TEMPERATURE FROM CLOSEST SIGMA LEVEL

   10  Z1=-H(I,J)*Z(K)
       IF(Z1.LT.FLOAT(N)-0.5) THEN
	K=K+1
	GOTO 10
       ENDIF
       K=MIN(K,KB)
       TZ(N)=TZ(N)+T(I,J,K-1)
       WTZ(N)=WTZ(N)+1.
   40  CONTINUE
   50  CONTINUE
   
C  CALCULATE AVERAGES

      DO 60 N=1,NTZ
      IF(WTZ(N).GT.0.) TZ(N)=TZ(N)/WTZ(N)+TBIAS
   60 CONTINUE

C  WRITE TO XDR FILE
   
      CALL XDRARRAY_FLOAT(19,TZ,NTZ)
      
C  REINTERPOLATE TO SIGMA LEVELS

      DO 100 J=1,JM
      DO 100 I=1,IM
       IF(FSM(I,J).EQ.0) GO TO 100
       DO 90 K=1,KBM1
	Z1=-H(I,J)*Z(K)
	N1=IFIX(Z1-0.5)+1
	W1=Z1-N1+0.5
	IF(Z1.LT.0.5) THEN
	 TMEAN(I,J,K)=TZ(1)-TBIAS
	ELSE
	 TMEAN(I,J,K)=(1.-W1)*TZ(N1)+W1*TZ(N1+1)-TBIAS
	ENDIF
   90  CONTINUE
  100  CONTINUE


      RETURN
      END


C$HP$ OPTIMIZE OFF


C **********************************************************************
C     This diagnostic code computes the vorticity budget of the
C     vertically integrated (external mode) momentun equations.
C     (See Ezer & Mellor, 1994: Diagnostic and prognostic calculations
C      of the North Atlantic circulation and sea level using a sigma
C      coordinate ocean model, JGR, 99(C7), 14,159-14,171).
C     USAGE: insert a periodic call after 
C
C 442 CONTINUE
C     IF(VAMAX.GT.VMAXL) GO TO 9001
C
CC    IF(MOD(IINT,IWRITE).EQ.0..AND.IEXT.EQ.ISPLIT/2)
C **** new pom97.f & latest versions
CC   1    CALL VORT(ADVUA,ADVVA,ADX2D,ADY2D,DRX2D,DRY2D,IM,JM)
C **** old pmod.f or pom.f codes
C    1    CALL VORT(ADVUA,ADVVA,adx2d,ady2d,drx2d,dry2d,IM,JM)
C
C   Note that variables' names in the subroutine are still as in old code.
C                                                                  T.E.
C **********************************************************************
C
C vorticity diagnostics
C
      SUBROUTINE VORT(IIM,JJM,IID)
       INCLUDE 'pomgl2007.h'    
C      DIMENSION adx2d(IIM,JJM),
C     1    ady2d(IIM,JJM),drx2d(IIM,JJM),dry2d(IIM,JJM)
      DIMENSION FX(IM,JM),FY(IM,JM),CTOT(IM,JM),CELG(IM,JM)
      DIMENSION CTSURF(IM,JM),CTBOT(IM,JM),CPVF(IM,JM)
      DIMENSION CJBAR(IM,JM),CADV(IM,JM),CTEN(IM,JM)
      DIMENSION CVOR(IM,JM)
C     DIMENSION TOTX(IM,JM),TOTY(IM,JM)
C
C --- IID=1 divide terms by D ; IID=0 no div. by D
C
      DO 90 I=2,IM
      DO 90 J=2,JM
      CTSURF(I,J)=0.
      CTBOT(I,J)=0.
      CPVF(I,J)=0.
      CJBAR(I,J)=0.
      CADV(I,J)=0.
      CTEN(I,J)=0.
      CELG(I,J)=0.
      CTOT(I,J)=0.
C     TOTX(I,J)=0.
C     TOTY(I,J)=0.
  90  CONTINUE

C
C --------------- surface stress term ------------------------
      DO 10 I=2,IM
      DO 10 J=2,JM
       IF(IID.EQ.1) THEN
      DMX=0.5*(D(I,J)+D(I-1,J))
      DMY=0.5*(D(I,J)+D(I,J-1))
       ELSE
      DMX=1.
      DMY=1.
       ENDIF
      FX(I,J)=WUSURF(I,J)/DMX
      FY(I,J)=WVSURF(I,J)/DMY
  10  CONTINUE
C     TOTX=TOTX+FX
C     TOTY=TOTY+FY
      CALL CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CTSURF,TCTSRF)
C
C --------------- bottom  stress term ------------------------
      DO 20 I=2,IM
      DO 20 J=2,JM
       IF(IID.EQ.1) THEN
      DMX=0.5*(D(I,J)+D(I-1,J))
      DMY=0.5*(D(I,J)+D(I,J-1))
       ELSE
      DMX=1.
      DMY=1.
       ENDIF
      FX(I,J)=-WUBOT(I,J)/DMX
      FY(I,J)=-WVBOT(I,J)/DMY
  20  CONTINUE
C     TOTX=TOTX+FX
C     TOTY=TOTY+FY
      CALL CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CTBOT,TCTBOT)
C
C ------------------ surf. elev. gradient term ---------------
C (if not divide by D this term = 0 due to continuity)
      ALPHA =0.225
C
      DO 30 I=2,IM
      DO 30 J=2,JM
       IF(IID.EQ.1) THEN
      DMX=0.5*(D(I,J)+D(I-1,J))
      DMY=0.5*(D(I,J)+D(I,J-1))
       ELSE
      DMX=1.
      DMY=1.
       ENDIF
      FX(I,J)=.25*GRAV*(DY(I,J)+DY(I-1,J))*(D(I,J)+D(I-1,J))
     4             *( (1.-2.*ALPHA)*(EL(I,J)-EL(I-1,J))
     4            +ALPHA*(ELB(I,J)-ELB(I-1,J)+ELF(I,J)-ELF(I-1,J)) )
      FX(I,J)=FX(I,J)/(ARU(I,J)*DMX)
C
      FY(I,J)=.250*GRAV*(DX(I,J)+DX(I,J-1))*(D(I,J)+D(I,J-1))
     4                   *( (1.0-2.0*ALPHA)*(EL(I,J)-EL(I,J-1))
     4            +ALPHA*(ELB(I,J)-ELB(I,J-1)+ELF(I,J)-ELF(I,J-1)) )
      FY(I,J)=FY(I,J)/(ARV(I,J)*DMY)
  30  CONTINUE
C     TOTX=TOTX+FX
C     TOTY=TOTY+FY
      CALL CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CELG,TCELG)
C
C -------------------- JBAR term (incl. elev grad)------------
      DO 40 I=2,IM
      DO 40 J=2,JM
       IF(IID.EQ.1) THEN
      DMX=0.5*(D(I,J)+D(I-1,J))
      DMY=0.5*(D(I,J)+D(I,J-1))
       ELSE
      DMX=1.
      DMY=1.
       ENDIF
      FX(I,J)=drx2d(I,J)/(ARU(I,J)*DMX)
      FY(I,J)=dry2d(I,J)/(ARV(I,J)*DMY)
  40  CONTINUE
C     TOTX=TOTX+FX
C     TOTY=TOTY+FY
      CALL CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CJBAR,TCJBAR)
C
CC    CJBAR=CJBAR+CELG
C
C --------------- advection and diffusion terms --------------
      DO 50 I=2,IM
      DO 50 J=2,JM
       IF(IID.EQ.1) THEN
      DMX=0.5*(D(I,J)+D(I-1,J))
      DMY=0.5*(D(I,J)+D(I,J-1))
       ELSE
      DMX=1.
      DMY=1.
       ENDIF
      FX(I,J)=(adx2d(I,J)+ADVUA(I,J))/(ARU(I,J)*DMX)
      FY(I,J)=(ady2d(I,J)+ADVVA(I,J))/(ARV(I,J)*DMY)
  50  CONTINUE
C     TOTX=TOTX+FX
C     TOTY=TOTY+FY
      CALL CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CADV,TCADV)
C
C ---------------------- coriolis term -----------------------
      DO 60 I=2,IM
      DO 60 J=2,JM
       IF(IID.EQ.1) THEN
      DMX=0.5*(D(I,J)+D(I-1,J))
      DMY=0.5*(D(I,J)+D(I,J-1))
       ELSE
      DMX=1.
      DMY=1.
       ENDIF
      FX(I,J)=-.25*(  COR(I,J)*D(I,J)*(VA(I,J+1)+VA(I,J))
     2        +COR(I-1,J)*D(I-1,J)*(VA(I-1,J+1)+VA(I-1,J)))/DMX
      FY(I,J)=+.25*(  COR(I,J)*D(I,J)*(UA(I+1,J)+UA(I,J))
     2        +COR(I,J-1)*D(I,J-1)*(UA(I+1,J-1)+UA(I,J-1)))/DMY
  60  CONTINUE
C     TOTX=TOTX+FX
C     TOTY=TOTY+FY
      CALL CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CPVF,TCPVF)
C
C ------------------ tendency (d/dt) term --------------------
      DO 70 I=2,IM
      DO 70 J=2,JM
       IF(IID.EQ.1) THEN
      DMX=0.5*(D(I,J)+D(I-1,J))
      DMY=0.5*(D(I,J)+D(I,J-1))
       ELSE
      DMX=1.
      DMY=1.
       ENDIF
      FX(I,J)=(UAF(I,J)*(H(I,J)+ELF(I,J)+H(I-1,J)+ELF(I-1,J))
     1  -UAB(I,J)*(H(I,J)+ELB(I,J)+H(I-1,J)+ELB(I-1,J)))/
     2  (4.*DTE*DMX)*DUM(I,J)
      FY(I,J)=(VAF(I,J)*(H(I,J)+ELF(I,J)+H(I,J-1)+ELF(I,J-1))
     1  -VAB(I,J)*(H(I,J)+ELB(I,J)+H(I,J-1)+ELB(I,J-1)))/
     2  (4.*DTE*DMY)*DVM(I,J)
  70  CONTINUE
C     TOTX=TOTX+FX
C     TOTY=TOTY+FY
      CALL CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CTEN,TCTEN)
C ------------------------ vorticity --------------------------
      DO 75 I=2,IM
      DO 75 J=2,JM
       IF(IID.EQ.1) THEN
      DMX=0.5*(D(I,J)+D(I-1,J))
      DMY=0.5*(D(I,J)+D(I,J-1))
       ELSE
      DMX=1.
      DMY=1.
       ENDIF
      FX(I,J)=UAF(I,J)*(H(I,J)+ELF(I,J)+H(I-1,J)+ELF(I-1,J))
     1  /(2.*DMX)*DUM(I,J)
      FY(I,J)=VAF(I,J)*(H(I,J)+ELF(I,J)+H(I,J-1)+ELF(I,J-1))
     1  /(2.*DMY)*DVM(I,J)
  75  CONTINUE
  
      CALL CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CVOR,TCVOR)
C
      TCTOT=0.
      DO 80 I=2,IM
      DO 80 J=2,JM
      CTOT(I,J)=CTSURF(I,J)+CTBOT(I,J)+CPVF(I,J)+CJBAR(I,J)
     1   +CTEN(I,J)+CADV(I,J)
      TCTOT=TCTOT+CTOT(I,J)
C     TOTX(I,J)=TOTX(I,J)*DUM(I,J)*DUM(I-1,J)
C     TOTY(I,J)=TOTY(I,J)*DVM(I,J)*DVM(I,J-1)
  80  CONTINUE
C     TOTX(1,:)=0.
C     TOTX(2,:)=0.
C     TOTX(:,1)=0.
C     TOTX(:,2)=0.
C     TOTX(IM,:)=0.
C     TOTX(:,JM)=0.
C     TOTY(1,:)=0.
C     TOTY(2,:)=0.
C     TOTY(:,1)=0.
C     TOTY(:,2)=0.
C     TOTY(IM,:)=0.
C     TOTY(:,JM)=0.
C
C       CALL PRXY('  CTSURF   ',TIME,CTSURF ,IM,3,JM,3,0.0)
C        CALL PRXY('  CTBOT    ',TIME,CTBOT  ,IM,3,JM,3,0.0)
C        CALL PRXY('  CPVF     ',TIME,CPVF   ,IM,3,JM,3,0.0)
C        CALL PRXY('  CJBAR    ',TIME,CJBAR  ,IM,3,JM,3,0.0)
C        CALL PRXY('  CTEN     ',TIME,CTEN   ,IM,3,JM,3,0.0)
C        CALL PRXY('  CELG     ',TIME,CELG   ,IM,3,JM,3,0.0)
C        CALL PRXY('  CADV     ',TIME,CADV   ,IM,3,JM,3,0.0)
C       CALL PRXY('  CTOT     ',TIME,CTOT   ,IM,3,JM,3,0.0)
C       CALL PRXY('   TOTX    ',TIME,TOTX   ,IM,3,JM,3,0.0)
C       CALL PRXY('   TOTY    ',TIME,TOTY   ,IM,3,JM,3,0.0)
C
C       WRITE(95) CELG,CTBOT,CPVF,CJBAR,CADV,CTEN
C
      WRITE(95,'(9E15.5)') TCTSRF,TCTBOT,TCELG,TCJBAR,TCADV,
     1 TCPVF,TCTEN,TCTOT,TCVOR
      RETURN
      END
C
C
C --------------------------------------------------------------------
C
      SUBROUTINE CURL(FX,FY,DX,DY,DUM,DVM,IM,JM,CF,TCF)
C
      DIMENSION FX(IM,JM),FY(IM,JM),DX(IM,JM),DY(IM,JM)
      DIMENSION CF(IM,JM),DUM(IM,JM),DVM(IM,JM)
C
      TCF=0.
      DO I=3,IM-1
      DO J=3,JM-1
C
      C=-FX(I,J)*(DX(I,J)+DX(I-1,J))+FX(I,J-1)*(DX(I,J-1)+DX(I-1,J-1))
     2  +FY(I,J)*(DY(I,J)+DY(I,J-1))-FY(I-1,J)*(DY(I-1,J)+DY(I-1,J-1))
      CF(I,J)=   C*DUM(I,J)*DUM(I,J-1)*DVM(I,J)*DVM(I-1,J)
C
      AREA   =   0.25*(DX(I,J)+DX(I-1,J) +DX(I,J-1)+DX(I-1,J-1))
     2          *0.25*(DY(I,J)+DY(I,J-1) +DY(I-1,J)+DY(I-1,J-1))
      CF(I,J)=CF(I,J)/AREA
      TCF=TCF+CF(I,J)
C
      ENDDO
      ENDDO
      RETURN
      END
C      
