C***********************************************************************
C
C     Common blocks for pomgl2007
C
C***********************************************************************
C
C     Array sizes:
C
      integer
     $  im             ,imm1           ,imm2           ,jm             ,
     $  jmm1           ,jmm2           ,kb             ,kbm1           ,
     $  kbm2 

      integer
     $  LIJ,LIJ2,LIJK,LIJKM2,LIJM1,LIJKM1
C
C***********************************************************************
C
C     Set size of problem here:
C
      parameter
c     $ (im=120          ,jm=445          ,kb=14)
     $ (im=132          ,jm=644          ,kb=20)
c     $ (im=180          ,jm=310          ,kb=11)     
C
C***********************************************************************
C                                     
      parameter
     $ (imm1=im-1      ,imm2=im-2      ,jmm1=jm-1      ,jmm2=jm-2      ,
     $  kbm1=kb-1      ,kbm2=kb-2      )

      PARAMETER (LIJ=IM*JM,LIJ2=LIJ*2,LIJK=LIJ*KB,LIJKM2=LIJ*KBM2)
      PARAMETER (LIJM1=IM*(JM-1),LIJKM1=LIJ*KBM1)

C
C-----------------------------------------------------------------------
C
C     Scalars:
C
      real
     $  alpha          ,dte            ,dti            ,dti2           ,  
     $  grav           ,hmax           ,kappa          ,pi             ,
     $  ramp           ,rfe            ,rfn            ,rfs            ,
     $  rfw            ,rhoref         ,sbias          ,slmax          ,
     $  small          ,tbias          ,time           ,tprni          ,
     $  umol           ,vmaxl          ,sw             ,depmax         ,
     $  aam_init       ,wlavg          ,wltot

      integer
     $  iint           ,iprint         ,iskp           ,jskp           ,
     $  kl1            ,kl2            ,mode           ,ntp            ,
     $  nadv           ,nitera         ,nbct           ,nbcs           ,
     $  nread          ,ICE

C
      common/blkcon/ 
     $  alpha          ,dte            ,dti            ,dti2           ,
     $  grav           ,hmax           ,kappa          ,pi             ,
     $  ramp           ,rfe            ,rfn            ,rfs            ,
     $  rfw            ,rhoref         ,sbias          ,slmax          ,
     $  small          ,tbias          ,time           ,tprni          ,
     $  umol           ,vmaxl          ,sw             ,depmax         ,
     $  aam_init                                                       ,
     $  iint           ,iprint         ,iskp           ,jskp           ,
     $  kl1            ,kl2            ,mode           ,ntp            ,
     $  nadv           ,nitera         ,nbct           ,nbcs           ,
     $  nread
C
C-----------------------------------------------------------------------
C
C     1-D arrays:
C
      real
     $  dz             ,dzz            ,z              ,zz
C
      common/blk1d/ 
     $  dz(kb)         ,dzz(kb)        ,z(kb)          ,zz(kb) 
C
C-----------------------------------------------------------------------
C
C     2-D arrays:
C
      real
     $  aam2d          ,advua          ,advva          ,adx2d          ,
     $  ady2d          ,art            ,aru            ,arv            ,
     $  cbc            ,cor            ,d              ,drx2d          ,
     $  dry2d          ,dt             ,dum            ,dvm            ,
     $  dx             ,dy             ,east_c         ,east_e         ,
     $  east_u         ,east_v         ,e_atmos        ,egb            ,
     $  egf            ,el             ,elb            ,elf            ,
     $  et             ,etb            ,etf            ,fluxua         ,
     $  fluxva         ,fsm            ,h              ,north_c        ,
     $  north_e        ,north_u        ,north_v        ,psi            ,
     $  rot            ,ssurf          ,swrad          ,vfluxb         ,
     $  tps            ,tsurf          ,ua             ,vfluxf         ,
     $  uab            ,uaf            ,utb            ,utf            ,
     $  va             ,vab            ,vaf            ,CICE           ,
     $  vtb            ,vtf            ,wssurf         ,wtsurf         ,
     $  wubot          ,wusurf         ,wvbot          ,wvsurf
C
      common/blk2d/
     $  aam2d(im,jm)   ,advua(im,jm)   ,advva(im,jm)   ,adx2d(im,jm)   ,
     $  ady2d(im,jm)   ,art(im,jm)     ,aru(im,jm)     ,arv(im,jm)     ,
     $  cbc(im,jm)     ,cor(im,jm)     ,d(im,jm)       ,drx2d(im,jm)   ,
     $  dry2d(im,jm)   ,dt(im,jm)      ,dum(im,jm)     ,dvm(im,jm)     ,
     $  dx(im,jm)      ,dy(im,jm)      ,east_c(im,jm)  ,east_e(im,jm)  ,
     $  east_u(im,jm)  ,east_v(im,jm)  ,e_atmos(im,jm) ,egb(im,jm)     ,
     $  egf(im,jm)     ,el(im,jm)      ,elb(im,jm)     ,elf(im,jm)     ,
     $  et(im,jm)      ,etb(im,jm)     ,etf(im,jm)     ,fluxua(im,jm)  ,
     $  fluxva(im,jm)  ,fsm(im,jm)     ,h(im,jm)       ,north_c(im,jm) ,
     $  north_e(im,jm) ,north_u(im,jm) ,north_v(im,jm) ,psi(im,jm)     ,
     $  rot(im,jm)     ,ssurf(im,jm)   ,swrad(im,jm)   ,vfluxb(im,jm)  ,
     $  tps(im,jm)     ,tsurf(im,jm)   ,ua(im,jm)      ,vfluxf(im,jm)  ,
     $  uab(im,jm)     ,uaf(im,jm)     ,utb(im,jm)     ,utf(im,jm)     ,
     $  va(im,jm)      ,vab(im,jm)     ,vaf(im,jm)     ,CICE(IM,JM)    ,
     $  vtb(im,jm)     ,vtf(im,jm)     ,wssurf(im,jm)  ,wtsurf(im,jm)  ,
     $  wubot(im,jm)   ,wusurf(im,jm)  ,wvbot(im,jm)   ,wvsurf(im,jm)
C
C-----------------------------------------------------------------------
C
C     3-D arrays:
C
      real 
     $  aam            ,advx           ,advy           ,a              ,
     $  c              ,drhox          ,drhoy          ,dtef           ,
     $  ee             ,gg             ,kh             ,km             ,
     $  kq             ,l              ,q2b            ,q2             ,
     $  q2lb           ,q2l            ,rho            ,rmean          ,
     $  sb             ,smean          ,s              ,tb             ,
     $  tmean          ,t              ,ub             ,uf             ,
     $  u              ,vb             ,vf             ,v              ,
     $  w              ,zflux
C
      common/blk3d/
     $  aam(im,jm,kb)  ,advx(im,jm,kb) ,advy(im,jm,kb) ,a(im,jm,kb)    ,
     $  c(im,jm,kb)    ,drhox(im,jm,kb),drhoy(im,jm,kb),dtef(im,jm,kb) ,
     $  ee(im,jm,kb)   ,gg(im,jm,kb)   ,kh(im,jm,kb)   ,km(im,jm,kb)   ,
     $  kq(im,jm,kb)   ,l(im,jm,kb)    ,q2b(im,jm,kb)  ,q2(im,jm,kb)   ,
     $  q2lb(im,jm,kb) ,q2l(im,jm,kb)  ,rho(im,jm,kb)  ,rmean(im,jm,kb),
     $  sb(im,jm,kb)   ,smean(im,jm,kb),s(im,jm,kb)    ,tb(im,jm,kb)   ,
     $  tmean(im,jm,kb),t(im,jm,kb)    ,ub(im,jm,kb)   ,uf(im,jm,kb)   ,
     $  u(im,jm,kb)    ,vb(im,jm,kb)   ,vf(im,jm,kb)   ,v(im,jm,kb)    ,
     $  w(im,jm,kb)    ,zflux(im,jm,kb)
C
C-----------------------------------------------------------------------
C
C     1 and 2-D boundary value arrays:
C
      real
     $  ele            ,eln            ,els            ,elw            ,
     $  sbe            ,sbn            ,sbs            ,sbw            ,
     $  tbe            ,tbn            ,tbs            ,tbw            ,
     $  uabe           ,uabw           ,ube            ,ubw            ,
     $  vabn           ,vabs           ,vbn            ,vbs       
C
      common/bdry/
     $  ele(jm)        ,eln(im)        ,els(im)        ,elw(jm)        ,
     $  sbe(jm,kb)     ,sbn(im,kb)     ,sbs(im,kb)     ,sbw(jm,kb)     ,
     $  tbe(jm,kb)     ,tbn(im,kb)     ,tbs(im,kb)     ,tbw(jm,kb)     ,
     $  uabe(jm)       ,uabw(jm)       ,ube(jm,kb)     ,ubw(jm,kb)     ,
     $  vabn(im)       ,vabs(im)       ,vbn(im,kb)     ,vbs(im,kb)
C
C-----------------------------------------------------------------------
C
C     Character variables:
C
      CHARACTER*80 FNAME,FGRID,FINPUT,FOUT,FINIT,FRSTRT


C------------- OTHER VARIABLES USED IN POMGL ------------------------


      integer
     $  IHRS,NFSM,NDUM,NDVM,
     $  ISPLIT,NLEVEL,ISPADV,ISFLUX,
     $  IRSTRT,IPSWR,ITMEAN,
     $  IYR,IJD,IHR,IYR0,IJD0,IHR0,ISEC,NOUT,IJKOUT,
     $  IAVG,INEUTR,NRSTRT,NRSKIP,
     $  IPARM,IBC,NIBC,N  

      real
     $  DTWIND,
     $  DS,HORCON,
     $  SMOTH,RAMPDT,DADD,AAMZ,CBCMIN,
     $  VAMAX,
     $  SMAGOR,YAMADA,YAMADA1,TAUX,TAUY,
     $  RPARM, 
     $  LHF,SHF,LWR,
     $  TAUX1,TAUY1,TAUX2,
     $  TAUY2,SHFX1,SHFX2,SWFX1,
     $  SWFX2,LWFX1,LWFX2,HSFX1,
     $  HSFX2,HLFX1,HLFX2,
     $  DZR,
     $  ALON,ALAT,
     $  UTM,VTM,
     $  UM,VM,KMM,KHM,
     $  COVRHN,COVRHE


      COMMON/POMGL/
     1     DTWIND,IHRS,NFSM,NDUM,NDVM,FNAME,FGRID,FINPUT,FOUT,
     2     FINIT,FRSTRT,ISPLIT,DS,NLEVEL,HORCON,ISPADV,ISFLUX,
     3     SMOTH,RAMPDT,DADD,CBCMIN,IRSTRT,IPSWR,ITMEAN,
     4     IYR,IJD,IHR,IYR0,IJD0,IHR0,ISEC,VAMAX,NOUT,IJKOUT(9,1000),
     5     SMAGOR,YAMADA,YAMADA1,IAVG,TAUX,TAUY,INEUTR,NRSTRT,NRSKIP,
     6     WLTOT,ICE
      COMMON/GPARM/RPARM(23),IPARM(54)  
      COMMON /BCCOM/ IBC(3,5000)
      COMMON /FLUXES/ LHF(IM,JM),SHF(IM,JM),LWR(IM,JM)
      COMMON /FLX2/ TAUX1(IM,JM),TAUY1(IM,JM),TAUX2(IM,JM),
     1     TAUY2(IM,JM),SHFX1(IM,JM),SHFX2(IM,JM),SWFX1(IM,JM),
     2     SWFX2(IM,JM),LWFX1(IM,JM),LWFX2(IM,JM),HSFX1(IM,JM),
     3     HSFX2(IM,JM),HLFX1(IM,JM),HLFX2(IM,JM)
      COMMON/MISC/
     1     DZR(KB),
     2     ALON(IM,JM),ALAT(IM,JM),
     3     UTM(IM,JM),VTM(IM,JM),
     4     UM(IM,JM,KB),VM(IM,JM,KB),KMM(IM,JM,KB),KHM(IM,JM,KB)
